extern "C"{
cfidrEncapsulatedViewIdT cfidrCellCreateEncapsulatedView (
                         cfidrCellIdT owner,
 		         cfidrStringT name,
			 cfidrStringT type,
			 cfidrStringT key,
			 cfidrErrorT *error);

cfidrNetlistViewIdT cfidrCellCreateNetlistView (
                         cfidrCellIdT owner,
			 cfidrStringT name,
			 cfidrErrorT *error);

cfidrLibIdT         cfidrCellGetOwner (
                         cfidrCellIdT object, 
			 cfidrErrorT *error);

cfidrViewsIdT       cfidrCellGetViews (
			 cfidrCellIdT object, 
			 cfidrErrorT *error);

cfidrBooleanT       cfidrInstCheckDescriber (
                         cfidrInstIdT object, 
		         cfidrErrorT *error);

cfidrNetlistViewIdT cfidrInstGetDescriber (
                         cfidrInstIdT object, 
			 cfidrErrorT *error);

cfidrNetlistViewIdT cfidrInstGetOwner (
                         cfidrInstIdT object, 
			 cfidrErrorT *error);

cfidrPortInstsIdT   cfidrInstGetPortInsts (
                         cfidrInstIdT object,
			 cfidrIterModeT mode, 
			 cfidrErrorT *error);

cfidrCellIdT        cfidrIterNextCell (
                         cfidrCellsIdT iter, 
			 cfidrErrorT *error);

cfidrInstIdT        cfidrIterNextInst (
                         cfidrInstsIdT iter, 
			 cfidrErrorT *error);

cfidrLibIdT         cfidrIterNextLib (
                         cfidrLibsIdT iter, 
			 cfidrErrorT *error);

cfidrNetIdT         cfidrIterNextNet (
                         cfidrNetsIdT iter, 
			 cfidrErrorT *error);

cfidrNetBundleIdT   cfidrIterNextNetBundle (
                         cfidrNetBundlesIdT iter, 
			 cfidrErrorT *error);

cfidrPortIdT        cfidrIterNextPort (
                         cfidrPortsIdT iter, 
			 cfidrErrorT *error);

cfidrPortInstIdT    cfidrIterNextPortInst (
                         cfidrPortInstsIdT iter, 
			 cfidrErrorT *error);

cfidrPropIdT        cfidrIterNextProp (
                         cfidrPropsIdT iter, 
			 cfidrErrorT *error);

cfidrViewIdT        cfidrIterNextView (
                         cfidrViewsIdT iter, 
			 cfidrErrorT *error);

cfidrVoidT          cfidrIterQuit (
                         cfidrIterIdT iter, 
			 cfidrErrorT *error);

cfidrVoidT          cfidrIterReset (
                         cfidrIterIdT iter, 
                         cfidrErrorT *error);

cfidrCellIdT        cfidrLibCreateCell (
                         cfidrLibIdT owner,
                         cfidrStringT name,
                         cfidrErrorT *error);

cfidrCellsIdT       cfidrLibGetCells (
                         cfidrLibIdT object, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrLibPurge (
                         cfidrLibIdT object, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrLibSave (
                         cfidrLibIdT object, 
                         cfidrErrorT *error);

cfidrStringT        cfidrNamedObjectGetName (
                         cfidrNamedObjectIdT object,
                         cfidrErrorT *error);

cfidrVoidT          cfidrNamedObjectSetName (
                         cfidrNamedObjectIdT object,
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetAttachPort (
                         cfidrNetIdT object,
			 cfidrPortIdT port,
			 cfidrAttachModeT mode, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetAttachPortInst (
                         cfidrNetIdT object,
			 cfidrPortInstIdT portInst,
			 cfidrAttachModeT mode, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetDetachPort (
                         cfidrNetIdT object, 
		         cfidrPortIdT port, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetDetachPortInst (
                         cfidrNetIdT object,
			 cfidrPortInstIdT portInst, 
                         cfidrErrorT *error);

cfidrNetBundlesIdT  cfidrNetGetNetBundles (
                         cfidrNetIdT id, 
                         cfidrErrorT *error);

cfidrNetlistViewIdT cfidrNetGetOwner (
                         cfidrNetIdT object, 
                         cfidrErrorT *error);

cfidrPortsIdT       cfidrNetGetPorts (
                         cfidrNetIdT object,
                         cfidrErrorT *error);


cfidrPortInstsIdT   cfidrNetGetPortInsts (
                         cfidrNetIdT object,
                         cfidrErrorT *error);

cfidrNetIdT         cfidrNetBundleFindNetByPosition (
                         cfidrNetBundleIdT netBundle, 
                         cfidrInt32T position, 
                         cfidrErrorT *error);


cfidrNetsIdT        cfidrNetBundleGetNets (
                         cfidrNetBundleIdT netB,
			 cfidrIterModeT mode, 
                         cfidrErrorT *error);

cfidrInt32T         cfidrNetBundleGetSize (
                         cfidrNetBundleIdT netBundle,
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetBundleInsertNet (
                         cfidrNetBundleIdT owner,
			 cfidrNetIdT net,
			 cfidrInt32T position,
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetBundleRemoveNet (
                         cfidrNetBundleIdT owner,
			 cfidrInt32T position,
                         cfidrErrorT *error);

cfidrInt32T         cfidrNetBusGetStart (
                         cfidrNetBusIdT netBus,
                         cfidrErrorT *error);

cfidrInt32T         cfidrNetBusGetStep (
                         cfidrNetBusIdT netBus,
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetBusSetStart (
                         cfidrNetBusIdT netBus,
		         cfidrInt32T start,
                         cfidrErrorT *error);

cfidrVoidT          cfidrNetBusSetStep (
                         cfidrNetBusIdT netBus,
                         cfidrInt32T step,
                         cfidrErrorT *error);

cfidrBooleanT       cfidrNetScalarGetIsGlobal (
                         cfidrNetScalarIdT netScalar,
                         cfidrErrorT* error);

cfidrVoidT          cfidrNetScalarSetIsGlobal (
                         cfidrNetScalarIdT netScalar,
                         cfidrBooleanT value,
                         cfidrErrorT* error);

cfidrPropIdT        cfidrObjectCreateProp (
                         cfidrObjectIdT owner,
                         cfidrStringT name,
                         cfidrErrorT *error);

cfidrVoidT          cfidrObjectDestroy (
                         cfidrObjectIdT object, 
                         cfidrErrorT *error);

cfidrObjectTypeT    cfidrObjectGetObjectType (
                         cfidrObjectIdT object, 
                         cfidrErrorT *error);

cfidrPropsIdT       cfidrObjectGetProps (
                         cfidrObjectIdT object, 
                         cfidrErrorT *error);

cfidrBooleanT       cfidrObjectIsNull (
                         cfidrObjectIdT object,
                         cfidrErrorT *error);

cfidrBooleanT       cfidrObjectIsSame (
                         cfidrObjectIdT object1,
                         cfidrObjectIdT object2, 
                         cfidrErrorT *error);

cfidrBooleanT       cfidrObjectIsUsable (
                         cfidrObjectIdT object,
                         cfidrErrorT *error);

cfidrLibIdT         cfidrPICreateLib (
                         cfidrStringT name,
                         cfidrErrorT *error);

cfidrStringT        cfidrPIGetErrorText (
                         cfidrErrorT errorForText, 
                         cfidrErrorT *error);

cfidrLibsIdT        cfidrPIGetLibs (
                         cfidrErrorT *error);

cfidrObjectIdT      cfidrPIGetNullId (
                         cfidrErrorT *error);

cfidrVoidT          cfidrPIInit (
                         cfidrErrorT *error);

cfidrLibIdT         cfidrPIOpenLib (
                         cfidrStringT name,
                         cfidrAccessModeT mode,
                         cfidrErrorT *error);

cfidrViewIdT        cfidrPIOpenView (
                         cfidrStringT libname,
                         cfidrStringT cellname,
                         cfidrStringT viewname,
                         cfidrAccessModeT mode, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrPIQuit (
                         cfidrErrorT *error);

cfidrPortDirectionT cfidrPortScalarGetDirection (
                         cfidrPortScalarIdT object, 
                         cfidrErrorT *error);

cfidrObjectIdT      cfidrPortGetOwner (
                         cfidrPortIdT object, 
                         cfidrErrorT *error);

cfidrInt32T         cfidrPortGetPosition (
                         cfidrPortIdT object, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrPortSetOwnerPortBundle (
                         cfidrPortIdT port,
                         cfidrPortBundleIdT owner,
                         cfidrInt32T position,
                         cfidrErrorT *error);

cfidrVoidT          cfidrPortSetOwnerView (
                         cfidrPortIdT port,
                         cfidrInt32T position,
                         cfidrErrorT *error);

cfidrPortBundleIdT  cfidrPortBundleCreatePortBundle (
                         cfidrPortBundleIdT owner,
                         cfidrStringT name,
                         cfidrInt32T position,
                         cfidrErrorT *error);

cfidrPortBusIdT     cfidrPortBundleCreatePortBus (
                         cfidrPortBundleIdT owner,
                         cfidrStringT name,
                         cfidrInt32T position,
                         cfidrInt32T start,
                         cfidrInt32T step,
                         cfidrErrorT *error);

cfidrPortScalarIdT  cfidrPortBundleCreatePortScalar (
                         cfidrPortBundleIdT owner,
                         cfidrStringT name,
                         cfidrInt32T position,
                         cfidrPortDirectionT direction,
                         cfidrErrorT *error);

cfidrPortIdT        cfidrPortBundleFindPortByPosition (
                         cfidrPortBundleIdT owner,
                         cfidrInt32T position,
                         cfidrErrorT *error);

cfidrNetBundlesIdT  cfidrPortBundleGetNetBundles (
                         cfidrPortBundleIdT obj,
                         cfidrErrorT *error);

cfidrPortsIdT       cfidrPortBundleGetPorts (
                         cfidrPortBundleIdT object,
                         cfidrIterModeT mode, 
                         cfidrErrorT *error);

cfidrInt32T         cfidrPortBundleGetSize (
                         cfidrPortBundleIdT object,
                         cfidrErrorT *error);

cfidrInt32T         cfidrPortBusGetStart (
                         cfidrPortBusIdT portBus,
                         cfidrErrorT *error);

cfidrInt32T         cfidrPortBusGetStep (
                         cfidrPortBusIdT portBus,
                         cfidrErrorT *error);

cfidrVoidT          cfidrPortBusSetStart (
                         cfidrPortBusIdT portBus,
                         cfidrInt32T start,
                         cfidrErrorT *error);

cfidrVoidT          cfidrPortBusSetStep (
                         cfidrPortBusIdT portBus,
                         cfidrInt32T step,
                         cfidrErrorT *error);

cfidrNetScalarIdT   cfidrPortScalarGetNetScalar (
                         cfidrPortScalarIdT object, 
                         cfidrErrorT *error);

cfidrBooleanT       cfidrPortInstCheckDescriber (
                         cfidrPortInstIdT object, 
                         cfidrErrorT *error);

cfidrPortIdT        cfidrPortInstGetDescriber (
                         cfidrPortInstIdT object, 
                         cfidrErrorT *error);

cfidrPortDirectionT cfidrPortInstScalarGetDescriberDirection (
                         cfidrPortInstScalarIdT object, 
                         cfidrErrorT *error);

cfidrStringT        cfidrPortInstGetDescriberName (
                         cfidrPortInstIdT object, 
                         cfidrErrorT *error);

cfidrInstIdT        cfidrPortInstGetOwner (
                         cfidrPortInstIdT object, 
                         cfidrErrorT *error);

cfidrNetBundlesIdT  cfidrPortInstBundleGetNetBundles (
                         cfidrPortInstBundleIdT object,
                         cfidrErrorT *error);

cfidrPortInstsIdT   cfidrPortInstBundleGetPortInsts (
                         cfidrPortInstBundleIdT object,
                         cfidrIterModeT mode, 
                         cfidrErrorT *error);

cfidrInt32T         cfidrPortInstBundleGetSize (
                         cfidrPortInstBundleIdT portInstBundle,
                         cfidrErrorT *error);

cfidrInt32T         cfidrPortInstBusGetStart (
                         cfidrPortInstBusIdT portInstBus, 
                         cfidrErrorT *error);

cfidrInt32T         cfidrPortInstBusGetStep (
                         cfidrPortInstBusIdT portInstBus, 
                         cfidrErrorT *error);

cfidrNetScalarIdT   cfidrPortInstScalarGetNetScalar (
                         cfidrPortInstScalarIdT object, 
                         cfidrErrorT *error);

cfidrBooleanT       cfidrPropGetBooleanValue (
                         cfidrPropIdT object, 
                         cfidrErrorT *error);

cfidrFloat32T       cfidrPropGetFloat32Value (
                         cfidrPropIdT object, 
                         cfidrErrorT *error);

cfidrInt32T         cfidrPropGetInt32Value (
                         cfidrPropIdT object, 
                         cfidrErrorT *error);

cfidrObjectIdT      cfidrPropGetOwner (
                         cfidrPropIdT object, 
                         cfidrErrorT *error);

cfidrStringT        cfidrPropGetStringValue (
                         cfidrPropIdT object, 
                         cfidrErrorT *error);

cfidrValueTypeT     cfidrPropGetValueType (
                         cfidrPropIdT object, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrPropSetBooleanValue (
                         cfidrPropIdT object,
                         cfidrBooleanT value, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrPropSetFloat32Value (
                         cfidrPropIdT object,
                         cfidrFloat32T value, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrPropSetInt32Value (
                         cfidrPropIdT object,
                         cfidrInt32T value, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrPropSetStringValue (
                         cfidrPropIdT object,
                         cfidrStringT value, 
                         cfidrErrorT *error);

cfidrStringT        cfidrViewGetViewType (
                         cfidrViewIdT view,
                         cfidrErrorT *error);

cfidrStringT        cfidrEncapsulatedViewGetKey (
                         cfidrEncapsulatedViewIdT owner,
                         cfidrErrorT *error);

cfidrInstIdT        cfidrNetlistViewCreateInst (
                         cfidrNetlistViewIdT owner,
                         cfidrNetlistViewIdT desc,
                         cfidrStringT name,
                         cfidrErrorT *error);

cfidrNetBundleIdT   cfidrNetlistViewCreateNetBundle (
                         cfidrNetlistViewIdT owner, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrNetBusIdT      cfidrNetlistViewCreateNetBus (
                         cfidrNetlistViewIdT owner,
                         cfidrStringT name,
                         cfidrInt32T start,
                         cfidrInt32T step,
                         cfidrErrorT *error);

cfidrNetScalarIdT   cfidrNetlistViewCreateNetScalar (
                         cfidrNetlistViewIdT owner,
                         cfidrStringT name,
                         cfidrErrorT *error);

cfidrPortBundleIdT  cfidrNetlistViewCreatePortBundle (
                         cfidrNetlistViewIdT owner,
                         cfidrStringT name,
                         cfidrInt32T position,
                         cfidrErrorT *error);

cfidrPortBusIdT     cfidrNetlistViewCreatePortBus (
                         cfidrNetlistViewIdT owner,
                         cfidrStringT name,
                         cfidrInt32T position,
                         cfidrInt32T start,
                         cfidrInt32T step,
                         cfidrErrorT *error);

cfidrPortScalarIdT  cfidrNetlistViewCreatePortScalar (
                         cfidrNetlistViewIdT owner,
                         cfidrStringT name,
                         cfidrInt32T position,
                         cfidrPortDirectionT dir,
                         cfidrErrorT *error);

cfidrInstsIdT       cfidrNetlistViewGetInsts (
                         cfidrNetlistViewIdT object, 
                         cfidrErrorT *error);

cfidrNetsIdT        cfidrNetlistViewGetNets (
                         cfidrNetlistViewIdT object,
                         cfidrIterModeT mode, 
                         cfidrErrorT *error);

cfidrCellIdT        cfidrViewGetOwner (
                         cfidrViewIdT object, 
                         cfidrErrorT *error);

cfidrPortsIdT       cfidrNetlistViewGetPorts (
                         cfidrNetlistViewIdT object,
                         cfidrIterModeT mode, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrViewPurge (
                         cfidrViewIdT view, 
                         cfidrErrorT *error);

cfidrVoidT          cfidrViewSave (
                         cfidrViewIdT view, 
                         cfidrErrorT *error);

cfidrViewIdT        cfidrCellFindViewByName (
                         cfidrCellIdT cell, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrPortInstIdT    cfidrInstFindPortInstByDescriberName (
                         cfidrInstIdT inst, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrCellIdT        cfidrLibFindCellByName (
                         cfidrLibIdT library, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrNetIdT         cfidrNetBundleFindNetByName (
                         cfidrNetBundleIdT netBundle, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrNetBundleIdT   cfidrNetFindNetBundleByName (
                         cfidrNetIdT net, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrInstIdT        cfidrNetlistViewFindInstByName (
                         cfidrNetlistViewIdT view, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrNetIdT         cfidrNetlistViewFindNetByName (
                         cfidrNetlistViewIdT view, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrPortIdT        cfidrNetlistViewFindPortByName (
                         cfidrNetlistViewIdT view, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrPropIdT        cfidrObjectFindPropByName (
                         cfidrObjectIdT object, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrLibIdT         cfidrPIFindLibByName (
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrPortIdT        cfidrPortBundleFindPortByName (
                         cfidrPortBundleIdT portBundle, 
		         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrPortInstIdT    cfidrPortInstBundleFindPortInstByDescriberName (
                         cfidrPortInstBundleIdT portInstBundle, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrLibrarySelectorIdT cfidrIterNextLibrarySelector (
                         cfidrLibrarySelectorsIdT iter, 
                         cfidrErrorT *error);

cfidrViewSelectorIdT    cfidrIterNextViewSelector (
                         cfidrViewSelectorsIdT iter, 
                         cfidrErrorT *error);

cfidrStringT            cfidrLibSelectorGetLibName (
                         cfidrLibrarySelectorIdT selector, 
                         cfidrErrorT *error);
 
cfidrViewIdT            cfidrSelectorSetSelectView (
                         cfidrSelectorSetIdT owner, 
                         cfidrCellIdT cell,
                         cfidrErrorT *error);

cfidrSelectorSetIdT     cfidrPICreateSelectorSet (
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrSelectorSetIdT     cfidrPIOpenSelectorSet (
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrLibrarySelectorIdT cfidrSelectorSetCreateLibrarySelector (
                         cfidrSelectorSetIdT owner, 
                         cfidrStringT name, 
                         cfidrErrorT *error);

cfidrViewNameSelectorIdT cfidrSelectorSetCreateViewNameSelector (
                         cfidrSelectorSetIdT owner, 
                         cfidrStringT libname, 
			 cfidrStringT cellname, 
                         cfidrStringT viewname, 
                         cfidrErrorT *error);

cfidrViewTypeSelectorIdT cfidrSelectorSetCreateViewTypeSelector (
                         cfidrSelectorSetIdT owner, 
                         cfidrStringT libname, 
			 cfidrStringT cellname, 
                         cfidrStringT viewtype, 
                         cfidrErrorT *error);

cfidrLibrarySelectorsIdT cfidrSelectorSetGetLibrarySelectors (
                         cfidrSelectorSetIdT owner, 
                         cfidrErrorT *error);

cfidrViewSelectorsIdT   cfidrSelectorSetGetViewSelectors (
                         cfidrSelectorSetIdT owner, 
                         cfidrErrorT *error);

cfidrVoidT              cfidrSelectorSetPurge (
                         cfidrSelectorSetIdT owner, 
                         cfidrErrorT *error);

cfidrVoidT              cfidrSelectorSetSave (
                         cfidrSelectorSetIdT owner, 
                         cfidrErrorT *error);

cfidrStringT            cfidrViewNameSelectorGetCellName (
                         cfidrViewNameSelectorIdT selector, 
                         cfidrErrorT *error);

cfidrStringT            cfidrViewNameSelectorGetLibName (
                         cfidrViewNameSelectorIdT selector, 
                         cfidrErrorT *error);

cfidrStringT            cfidrViewNameSelectorGetViewName (
                         cfidrViewNameSelectorIdT selector, 
                         cfidrErrorT *error);

cfidrStringT            cfidrViewTypeSelectorGetCellName (
                         cfidrViewTypeSelectorIdT selector, 
                         cfidrErrorT *error);

cfidrStringT            cfidrViewTypeSelectorGetLibName (
                         cfidrViewTypeSelectorIdT selector, 
                         cfidrErrorT *error);

cfidrStringT            cfidrViewTypeSelectorGetViewType (
                         cfidrViewTypeSelectorIdT selector, 
                         cfidrErrorT *error);

}
