//*********************************************************************
//
//   FILE-NAME: extern.h
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet externe globale Variable Definitionen
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#include "consts.h"
//#include "classes.h"
#include "prot.h"

	// Definition von Prototypen
extern string_C operator + (string_C, string_C);
extern boolean operator == (string_C, string_C);
extern boolean element_in_liste(gate_liste_C, gate_C *);
extern boolean element_in_liste(line_liste_C, line_C *);

	// Definitionen von globalen Variablen siehe definitions.h
extern line_liste_C input_lines_C;
extern line_liste_C output_lines_C;
extern gate_liste_C gates_C;
extern line_liste_C lines_C;
extern line_C *search(char*,line_tree_u*);
extern gate_C *search(char*,gate_tree_u*);

extern char schaltungsname_s[stringsize_i];
extern double lambda_f;		// Lambda fuer Testbarkeitsanalyse

extern struct stat_t statistic_u;
extern struct line_tree_u *milef_line_tree_root_p;
extern struct gate_tree_u *milef_gate_tree_root_p;
