#include "consts.h"

#ifndef OPT_SPACE
ofstream& operator<<(ofstream &f,value_t e)
{
switch(e)
   {
   case VAL_0:
	f << "VAL_0";
	break;
   case VAL_1:
	f << "VAL_1";
	break;
   case VAL_0S:
	f << "VAL_0S";
	break;
   case VAL_1S:
	f << "VAL_1S";
	break;
   case VAL_0X:
	f << "VAL_0X";
	break;
   case VAL_1X:
	f << "VAL_1X";
	break;
   case VAL_D:
	f << "VAL_D";
	break;
   case VAL_D_BAR:
	f << "VAL_D_BAR";
	break;
   case VAL_X:
	f << "VAL_X";
	break;
   case UNDEFINED_VALUE:
	f << "UNDEFINED_VALUE";
	break;
   default:
	f << e;
   }//switch
return(f);
}//ofstream::operator<<

ofstream& operator<<(ofstream &f,boolean b)
{
switch(b)
   {
   case FALSE:
	f << "FALSE";
	break;
   case TRUE:
	f << "TRUE";
	break;
   }//switch
return(f);
}//ofstream::operator<<

ofstream& operator<<(ofstream &f,object_t e)
{
switch(e)
   {
   case GATE:
	f << "GATE";
	break;
   case LINE:
	f << "LINE";
	break;
   case UNDEFINED_OBJECT:
	f << "UNDEFINED_OBJECT";
	break;
   }//switch
return(f);
}//ofstream::operator<<

ofstream& operator<<(ofstream &f,gate_t e)
{
switch(e)
   {
   case AND:
	f << "AND";
	break;
   case OR:
	f << "OR";
	break;
   case NAND:
	f << "NAND";
	break;
   case NOR:
	f << "NOR";
	break;
   case EXOR:
	f << "EXOR";
	break;
   case INVERTER:
	f << "INVERTER";
	break;
   case DRIVER:
	f << "DRIVER";
	break;
   case BLOCK:
	f << "BLOCK";
	break;
   case D_LATCH:
	f << "D_LATCH";
	break;
   case D_FLIP_FLOP:
	f << "D_FLIP_FLOP";
	break;
   case FANOUT:
	f << "FANOUT";
	break;
   case UNDEFINED_GATE:
	f << "UNDEFINED_GATE";
	break;
   }//switch
return(f);
}//ofstream::operator<<

ofstream& operator<<(ofstream &f,line_t e)
{
switch(e)
   {
   case FREE_LINE:
	f << "FREE_LINE";
	break;
   case BOUND_LINE:
	f << "BOUND_LINE";
	break;
   case HEAD_LINE:
	f << "HEAD_LINE";
	break;
   case UNDEFINED_LINE:
	f << "UNDEFINED_LINE";
	break;
   }//switch
return(f);
}//ofstream::operator<<

ofstream& operator<<(ofstream &f,fan_result_t e)
{
switch(e)
   {
   case SUCCESS:
	f << "SUCCESS";
	break;
   case ABORTED_FAULT:
	f << "ABORTED_FAULT";
	break;
   case REDUNDANT_FAULT:
	f << "REDUNDANT_FAULT";
	break;
   case INCONSISTENT:
	f << "INCONSISTENT";
	break;
   case NO_IMPLICATION:
	f << "NO_IMPLICATION";
	break;
   case IMPLICATION_DONE:
	f << "IMPLICATION_DONE";
	break;
   }//switch
return(f);
}//ofstream::operator<<

ofstream& operator<<(ofstream &f,io_t e)
{
if (int(e) < 20)
	f<<"I"<<int(e)+1;
if ((int(e) > 19) && (int(e) < 40))
	f<<"O"<<int(e)-19;
switch(e)
   {
   case SET:
	f << "SET";
	break;
   case RESET:
	f << "RESET";
	break;
   case DATA:
	f << "DATA";
	break;
   case CLOCK:
	f << "CLOCK";
	break;
   case INPUT_J:
	f << "INPUT_J";
	break;
   case INPUT_K:
	f << "INPUT_K";
	break;
   case OUTPUT_Q:
	f << "OUTPUT_Q";
	break;
   case OUTPUT_Q_BAR:
	f << "OUTPUT_Q_BAR";
	break;
   case UNDEFINED_IO:
	f << "UNDEFINED_IO";
	break;
   default:
	break;
   }//switch
return(f);
}//ofstream::operator<<
#endif
