#include "stringliste_C.h"

stringliste_C::stringliste_C()
{
  // Initialisierung der Parameter
liste_a = new string_C*[max_number_gates_i];
if (liste_a == NULL)
	error("No more memory available");
listengroesse_i = 0;
max_listengroesse_i = 0;
aktuell_i = 0;
}//stringliste_C

stringliste_C::~stringliste_C()
{
  // zerstoert die Liste
for (int i=0;i<max_listengroesse_i;i++)
	delete liste_a[i];
delete[] liste_a;
}//~stringliste_C

//*********************************************************************
//
//   FUNCTION-NAME: entnehme
//
//   CLASS: stringliste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Der erste String wird aus der Liste genommen
//	und Ausgegeben. Das Element wird in der Liste geloescht. (zerstoerendes
//	Lesen). Die Listenindizes aller Element werden dann herabgesetzt um 1.
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: string_C: der entsprechende String
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
string_C stringliste_C::entnehme()
{
string_C s_sC = string_C(stringsize_i);
string_C *hilf_p;

if (listengroesse_i == 0)
	return("");
s_sC = *liste_a[0];
listengroesse_i--;
hilf_p = liste_a[0];
for (int i=0;i<listengroesse_i;i++)
	liste_a[i] = liste_a[i + 1];
liste_a[listengroesse_i] = hilf_p;
return(s_sC);
}

//*********************************************************************
//
//   FUNCTION-NAME: add_element
//
//   CLASS: stringliste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Der String wird ans Ende der Liste angehaengt.
//	listengroesse_i wird um 1 erhoeht
//
//   FORMAL PARAMETERS: string_C s_sC: der entsprechende String
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void stringliste_C::add_element(string_C s_sC)
{
char *s_s = s_sC;
	
if (listengroesse_i == max_listengroesse_i)
	{
	liste_a[listengroesse_i] = new string_C();
	if (liste_a[listengroesse_i] == NULL)
		error("no memory available");
	*liste_a[listengroesse_i] = s_sC;
	max_listengroesse_i++;
	}//if
else
	*liste_a[listengroesse_i] = s_sC;
listengroesse_i++;
}
