#include "extern.h"
#include "line_value_liste_C.h"
#include "line_C.h"
#include "gate_C.h"
#include "gate_liste_C.h"
#include "line_liste_C.h"

extern int redundanz_klassen_zahl_i;
extern int aborted_klassen_zahl_i;
extern int aequivalenzen_zahl_i;

extern boolean only_stuck_at_test_b;
extern boolean flt_read_b;
extern boolean stuck_at_test_without_branches_b;
extern boolean path_delay_test_b;
extern line_value_liste_C zielfehler_C;
extern line_value_liste_C hilf_C;
//typedef enum AEQUIVALENZ_TYP {no_Aequivalenz, no_Dominanz, Stuck_at_0, Stuck_at_1} ;
typedef struct have_test_result_t{
boolean		beziehung_b;
cube_list_t	*zeile_p;
};

//typedef struct dominanz_result_t{
//boolean VAL_0_b;
//boolean VAL_1_b;
//};

typedef enum TEST_TYP {abortet,redundant,testet } ;

AEQUIVALENZ_TYP out_Aequivalenztyp( line_C *, gate_t, AEQUIVALENZ_TYP ) ;
AEQUIVALENZ_TYP out_Dominanztyp(line_C *, gate_t, AEQUIVALENZ_TYP ) ;
void mark_redundanzen_towards_input(line_C* );
void zaehl_aequivalenzen(line_C *line_p);
void zaehl_redundanzen_towards_input(line_C* );
void zaehl_aequivalenzen_towards_input(line_C*, AEQUIVALENZ_TYP Fehlerart_out_e);
void zaehl_abort_u_redunant_klassen_towards_input(line_C * , AEQUIVALENZ_TYP );
void gib_redundanz_aborted_klassen_anzahl();
void gib_aequi_klassen_zahl();
void mark_all(line_C *line_p,AEQUIVALENZ_TYP Fehlerart_begin_in_e);
AEQUIVALENZ_TYP suche_nach_Dominanz(line_C *, value_t );
AEQUIVALENZ_TYP suche_nach_Aequivalenz(line_C * ,value_t );
have_test_result_t have_test(cube_list_t *test_zeile_p, cube_list_t *cube_array_p, int i, value_t testvalue_e, cube_list_t *other_cube_p);
boolean no_more_test( cube_list_t *test_zeile_p,cube_list_t *cube_array_p, int i, value_t testvalue_e, cube_list_t *other_cube_p);
boolean more_out_put_test( cube_list_t *cube_array_p, int i, value_t testvalue_e, cube_list_t *other_cube_p);
boolean vergleiche (cube_list_t *vergleich_zeile_p ,cube_list_t *test_zeile_p,int i);
boolean vergleiche(cube_list_t *test_zeile_p,cube_list_t *other_cube_p);
dominanz_result_t dominanz(gate_C *);
void print_cubes(gate_C *gate_item_p, cube_list_t *cube_0_array_p,cube_list_t *cube_1_array_p,int art);
void ziel_F_append();
extern void erstelle_zielfehlerliste(line_value_liste_C&);

int compare_zielfehler(const line_value_t **l1_p,const line_value_t **l2_p)
{
return((*l2_p)->line_p->gib_plane_no() - (*l1_p)->line_p->gib_plane_no());
//static double p1_f,p2_f;
//
//if ((*l1_p)->val_e == VAL_0)
//      p1_f = (*l1_p)->line_p->gib_observaby() * (*l1_p)->line_p->gib_zero_contby();
//else if ((*l1_p)->val_e == VAL_1)
//      p1_f = (*l1_p)->line_p->gib_observaby() * (*l1_p)->line_p->gib_one_contby();
//else
//      p1_f = (*l1_p)->line_p->gib_testaby();
//if ((*l2_p)->val_e == VAL_0)
//      p2_f = (*l2_p)->line_p->gib_observaby() * (*l2_p)->line_p->gib_zero_contby();
//else if ((*l2_p)->val_e == VAL_1)
//      p2_f = (*l2_p)->line_p->gib_observaby() * (*l2_p)->line_p->gib_one_contby();
//else
//      p2_f = (*l2_p)->line_p->gib_testaby();
//if (p1_f>p2_f)
//      return (1);
//if (p1_f<p2_f)
//      return (-1);
//else
//      return (0);
}//compare_zielfehler
int compare_zielfehler(const void *l1_p,const void *l2_p){return compare_zielfehler((const line_value_t **)l1_p, (const line_value_t **)l2_p);}

void mark_aequivalenzen_towards_input(line_C *line_p)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_out_e ;
line_C  *nachfolger_line_p, *vorgaenger_line_p;
boolean dummy1_b;
boolean dummy2_b;

nachfolger_line_p = line_p ;

if (nachfolger_line_p->is_primary_input() == FALSE )
 for (Fehlerart_in_e = Stuck_at_0;Fehlerart_in_e <= Stuck_at_1;Fehlerart_in_e = AEQUIVALENZ_TYP(int(Fehlerart_in_e)+1))
  for( int i =0; i<nachfolger_line_p->vorgaenger()->gib_only_gate()->no_inputs();i++)
   { vorgaenger_line_p = (*nachfolger_line_p->vorgaenger()->gib_only_gate()->gib_inputs())[i];
        if ((*vorgaenger_line_p->nachfolger())[0]->gib_type() != FANOUT )
	    {
	     Fehlerart_out_e = out_Aequivalenztyp( vorgaenger_line_p, (*vorgaenger_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if (Fehlerart_out_e != no_Aequivalenz)	     
	         {
		  if (Fehlerart_out_e == Stuck_at_0 && Fehlerart_in_e == Stuck_at_0)
		      {
	                if (((vorgaenger_line_p->get_s_a_0_test() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_0_aborted() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_0_untestable() == FALSE) &&
			    ((nachfolger_line_p->get_s_a_0_untestable() == TRUE) || (nachfolger_line_p->get_s_a_0_aborted()== TRUE)))
			    ||
			    ((vorgaenger_line_p->get_s_a_0_aborted() == TRUE)  &&
			     (nachfolger_line_p->get_s_a_0_untestable() == TRUE)))
			{
			vorgaenger_line_p->set_s_a_0_aborted(nachfolger_line_p->get_s_a_0_aborted());
			if (nachfolger_line_p->get_s_a_0_untestable() == TRUE)
				{
				vorgaenger_line_p->set_s_a_0_untestable();
				dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
				if (dummy1_b == TRUE)
					{
					dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
					if (dummy2_b == FALSE)
						hilf_C.fuege_ein(vorgaenger_line_p, VAL_0);
					}
				}
			mark_aequivalenzen_towards_input(vorgaenger_line_p);
			}
			if ((vorgaenger_line_p->get_s_a_0_test() == FALSE) && (nachfolger_line_p->get_s_a_0_test() == TRUE))
			{
			vorgaenger_line_p->set_s_a_0_test();
			vorgaenger_line_p->set_s_a_0_aborted(FALSE);
			dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
			if (dummy1_b == TRUE)
				{
				dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
				if (dummy2_b == FALSE)
					hilf_C.fuege_ein(vorgaenger_line_p, VAL_0);
				}
			if (vorgaenger_line_p->get_s_a_1_test() == TRUE)
					{
					vorgaenger_line_p->set_stuck_at_test();
					if ((only_stuck_at_test_b == TRUE) && ((vorgaenger_line_p->is_primary_input() == TRUE) ||
									       ((*vorgaenger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
							vorgaenger_line_p->set_test_done();
					}//if
			mark_aequivalenzen_towards_input(vorgaenger_line_p);
			}
		      }
		  if (Fehlerart_out_e == Stuck_at_1 && Fehlerart_in_e == Stuck_at_0)   
		      {
			if (((vorgaenger_line_p->get_s_a_0_test() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_0_aborted() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_0_untestable() == FALSE) &&
			    ((nachfolger_line_p->get_s_a_1_untestable() == TRUE) || (nachfolger_line_p->get_s_a_1_aborted()== TRUE))) 
			    ||
			    ((vorgaenger_line_p->get_s_a_0_aborted() == TRUE)  &&
			     (nachfolger_line_p->get_s_a_1_untestable() == TRUE)))
			{
			vorgaenger_line_p->set_s_a_0_aborted(nachfolger_line_p->get_s_a_1_aborted());
			if (nachfolger_line_p->get_s_a_1_untestable() == TRUE)
				{
				vorgaenger_line_p->set_s_a_0_untestable();
				dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
				if (dummy1_b == TRUE)
					{
					dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
					if (dummy2_b == FALSE)
						hilf_C.fuege_ein(vorgaenger_line_p, VAL_0);
					}
				}
			mark_aequivalenzen_towards_input(vorgaenger_line_p) ;
			}
			if ((vorgaenger_line_p->get_s_a_0_test() == FALSE) && (nachfolger_line_p->get_s_a_1_test() == TRUE))
			{
			vorgaenger_line_p->set_s_a_0_test();
			vorgaenger_line_p->set_s_a_0_aborted(FALSE);
			dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
			if (dummy1_b == TRUE)
				{
				dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_0,FALSE);
				if (dummy2_b == FALSE)
					hilf_C.fuege_ein(vorgaenger_line_p, VAL_0);
				}
			if (vorgaenger_line_p->get_s_a_1_test() == TRUE)
					{
					vorgaenger_line_p->set_stuck_at_test();
					if ((only_stuck_at_test_b == TRUE) && ((vorgaenger_line_p->is_primary_input() == TRUE) ||
									       ((*vorgaenger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
							vorgaenger_line_p->set_test_done();
					}//if
			mark_aequivalenzen_towards_input(vorgaenger_line_p);
			}
		      }
		  if (Fehlerart_out_e == Stuck_at_0 && Fehlerart_in_e == Stuck_at_1)
		      {
	                if (((vorgaenger_line_p->get_s_a_1_test() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_1_aborted() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_1_untestable() == FALSE) &&
			    ((nachfolger_line_p->get_s_a_0_untestable() == TRUE) || (nachfolger_line_p->get_s_a_0_aborted()== TRUE)))
			    ||
			    ((vorgaenger_line_p->get_s_a_1_aborted() == TRUE)  &&
			     (nachfolger_line_p->get_s_a_0_untestable() == TRUE)))
			{
	                if (vorgaenger_line_p->get_s_a_1_test()) break ;	      
		        vorgaenger_line_p->set_s_a_1_aborted(nachfolger_line_p->get_s_a_0_aborted());
			if (nachfolger_line_p->get_s_a_0_untestable() == TRUE)
				{
				vorgaenger_line_p->set_s_a_1_untestable();
				dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
				if (dummy1_b == TRUE)
					{
					dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
					if (dummy2_b == FALSE)
						hilf_C.fuege_ein(vorgaenger_line_p, VAL_1);
					}
				}
			mark_aequivalenzen_towards_input(vorgaenger_line_p) ;
			}
			if ((vorgaenger_line_p->get_s_a_1_test() == FALSE) && (nachfolger_line_p->get_s_a_0_test() == TRUE))
			{
			vorgaenger_line_p->set_s_a_1_test();
			vorgaenger_line_p->set_s_a_1_aborted(FALSE);
			dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
			if (dummy1_b == TRUE)
				{
				dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
				if (dummy2_b == FALSE)
					hilf_C.fuege_ein(vorgaenger_line_p, VAL_1);
				}
			if (vorgaenger_line_p->get_s_a_0_test() == TRUE)
					{
					vorgaenger_line_p->set_stuck_at_test();
					if ((only_stuck_at_test_b == TRUE) && ((vorgaenger_line_p->is_primary_input() == TRUE) ||
									       ((*vorgaenger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
							vorgaenger_line_p->set_test_done();
					}//if
			mark_aequivalenzen_towards_input(vorgaenger_line_p);
			}
		      }
		  if (Fehlerart_out_e == Stuck_at_1 && Fehlerart_in_e == Stuck_at_1 )   
		      {
	                if (((vorgaenger_line_p->get_s_a_1_test() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_1_aborted() == FALSE) &&
			    (vorgaenger_line_p->get_s_a_1_untestable() == FALSE) &&
			    ((nachfolger_line_p->get_s_a_1_untestable() == TRUE) ||(nachfolger_line_p->get_s_a_1_aborted()== TRUE)))
			    ||
			    ((vorgaenger_line_p->get_s_a_1_aborted() == TRUE)  &&
			     (nachfolger_line_p->get_s_a_1_untestable() == TRUE)))
			{
		        if (vorgaenger_line_p->get_s_a_1_test()) break ;
			vorgaenger_line_p->set_s_a_1_aborted(nachfolger_line_p->get_s_a_1_aborted());
			if (nachfolger_line_p->get_s_a_1_untestable() == TRUE)
				{
				vorgaenger_line_p->set_s_a_1_untestable();
				dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
				if (dummy1_b == TRUE)
					{dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
					if (dummy2_b == FALSE)
						hilf_C.fuege_ein(vorgaenger_line_p, VAL_1);
					}
				}
			mark_aequivalenzen_towards_input(vorgaenger_line_p) ;
			}
		        if ((vorgaenger_line_p->get_s_a_1_test() == FALSE)  && (nachfolger_line_p->get_s_a_1_test() == TRUE))
			{
			vorgaenger_line_p->set_s_a_1_test();
			vorgaenger_line_p->set_s_a_1_aborted(FALSE);
			dummy1_b = zielfehler_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
			if (dummy1_b == TRUE)
				{
				dummy2_b = hilf_C.element_in_liste(vorgaenger_line_p,VAL_1,FALSE);
				if (dummy2_b == FALSE)
					hilf_C.fuege_ein(vorgaenger_line_p, VAL_1);
				}
			if (vorgaenger_line_p->get_s_a_0_test() == TRUE)
					{
					vorgaenger_line_p->set_stuck_at_test();
					if ((only_stuck_at_test_b == TRUE) && ((vorgaenger_line_p->is_primary_input() == TRUE) ||
									       ((*vorgaenger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
							vorgaenger_line_p->set_test_done();
					}//if
			mark_aequivalenzen_towards_input(vorgaenger_line_p);
			}
										   
		      }
		 } //no_aequivalenz
	    } // FANOUT
   } //for
}

AEQUIVALENZ_TYP out_Aequivalenztyp(line_C *vorgaenger_line_p, gate_t gatter_e, AEQUIVALENZ_TYP in_e)
{
AEQUIVALENZ_TYP help_e;
value_t testvalue_e;

  switch(gatter_e)
  {
   case INVERTER   : if (in_e ==Stuck_at_0) return Stuck_at_1;
                                 else return Stuck_at_0;
				
				 
  case DRIVER     : if (in_e ==Stuck_at_0) return Stuck_at_0;
                                 else return Stuck_at_1;
				
				 

  case AND   : if (in_e ==Stuck_at_0) return Stuck_at_0;
                                 else return no_Aequivalenz ;
				

  case OR   : if (in_e ==Stuck_at_1) return Stuck_at_1;
                                 else return no_Aequivalenz;
				

  case NAND   : if (in_e ==Stuck_at_0) return Stuck_at_1;
				 else return no_Aequivalenz;
				 

  case NOR   : if (in_e ==Stuck_at_1) return Stuck_at_0;
                                  else return no_Aequivalenz;
				 
  case BLOCK :
		if (in_e == Stuck_at_1)
			testvalue_e = VAL_0;
		else
			testvalue_e = VAL_1;
		help_e = suche_nach_Aequivalenz(vorgaenger_line_p,testvalue_e );
		return help_e;
				   
  default    : return no_Aequivalenz ;
               
  }
}

AEQUIVALENZ_TYP out_Dominanztyp(line_C *vorgaenger_line_p, gate_t gatter_e, AEQUIVALENZ_TYP in_e)
{
value_t testvalue_e;
AEQUIVALENZ_TYP help_e;
  switch(gatter_e)
  {
  case INVERTER   : if (in_e ==Stuck_at_0) return Stuck_at_1;
                                 else return Stuck_at_0;
				
				 
  case DRIVER     : if (in_e ==Stuck_at_0) return Stuck_at_0;
                                 else return Stuck_at_1;
				
				 

  case AND   : if (in_e ==Stuck_at_1) return Stuck_at_1;
                                 else return no_Dominanz ;
				

  case OR   : if (in_e ==Stuck_at_0) return Stuck_at_0;
                                 else return no_Dominanz;
				

  case NAND   : if (in_e ==Stuck_at_1) return Stuck_at_0;
				 else return no_Dominanz;
				 

  case NOR   : if (in_e ==Stuck_at_0) return Stuck_at_1;
                                  else return no_Dominanz;
				 
  case BLOCK :
		if (in_e == Stuck_at_1)
			testvalue_e = VAL_0;
		else
			testvalue_e = VAL_1;
		help_e = suche_nach_Dominanz( vorgaenger_line_p,testvalue_e );
		return help_e;
				  
				   
  default    : return no_Dominanz ;
               
  }
}


/*Anzahl der Redundanzklassen nach Ermittlung der Zielfehlerliste
Aufruf mit forall Elemente der Zielfehlerliste
alle line_p->geprueft_b = stuck_at_0
		exists_signal_path_b = stuck_at_1 auf FALSE setzen**/


void zaehl_aequivalenzen(line_C *line_p)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_out_e ;
AEQUIVALENZ_TYP  Fehlerart_begin_in_e;
line_C  *item_line_p,*nachfolger_line_p;
boolean begin_b = TRUE;

if (only_stuck_at_test_b == FALSE)
	return;
item_line_p = line_p ;

for (Fehlerart_begin_in_e = Stuck_at_0;Fehlerart_begin_in_e <= Stuck_at_1;Fehlerart_begin_in_e = AEQUIVALENZ_TYP(int(Fehlerart_begin_in_e)+1),item_line_p = line_p,begin_b = TRUE)
if (((Fehlerart_begin_in_e == Stuck_at_0) && (item_line_p->geprueft_b == FALSE)) ||
    ((Fehlerart_begin_in_e == Stuck_at_1) && (item_line_p->signal_path_exist_b == FALSE)))
do
  {
     if (begin_b == TRUE)
             {
	        aequivalenzen_zahl_i++;
		if (Fehlerart_begin_in_e == Stuck_at_0)
			{
			item_line_p->geprueft_b = TRUE;
			item_line_p->aequiklass_at_0_nr_i = aequivalenzen_zahl_i;
			}
		if (Fehlerart_begin_in_e == Stuck_at_1)
			{
			item_line_p->signal_path_exist_b = TRUE;
			item_line_p->aequiklass_at_1_nr_i = aequivalenzen_zahl_i;
			}

		Fehlerart_in_e = Fehlerart_begin_in_e;
		begin_b = FALSE;
		
		zaehl_aequivalenzen_towards_input(item_line_p,Fehlerart_in_e);
	     }

	     
   if (item_line_p->is_primary_output() == FALSE )
      {
        if ((*item_line_p->nachfolger())[0]->gib_type() != FANOUT )
	    {
	     nachfolger_line_p = (*(*item_line_p->nachfolger())[0]->gib_outputs())[0];
	     Fehlerart_out_e = out_Aequivalenztyp(item_line_p,(*item_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if (Fehlerart_out_e != no_Aequivalenz)	     
	         {
			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_0))
				{
				nachfolger_line_p->geprueft_b = TRUE;
				nachfolger_line_p->aequiklass_at_0_nr_i = aequivalenzen_zahl_i;
				}
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_0))
				{
				nachfolger_line_p->geprueft_b = TRUE;
				nachfolger_line_p->aequiklass_at_0_nr_i = aequivalenzen_zahl_i;
				}

			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_1))
				{
				nachfolger_line_p->signal_path_exist_b = TRUE;
				nachfolger_line_p->aequiklass_at_1_nr_i = aequivalenzen_zahl_i;
				}
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_1))
				{
				nachfolger_line_p->signal_path_exist_b = TRUE;
				nachfolger_line_p->aequiklass_at_1_nr_i = aequivalenzen_zahl_i;
				}

			item_line_p = nachfolger_line_p ;
			zaehl_aequivalenzen_towards_input(item_line_p,Fehlerart_out_e);



		  Fehlerart_in_e = Fehlerart_out_e;    
										   
		 }
	       else
		    {
			zaehl_aequivalenzen_towards_input(item_line_p,Fehlerart_out_e);
			zaehl_aequivalenzen(nachfolger_line_p); //fuer Aequivalenzen tiefer in der Fanoutfreien Zone
			break;
		    }
	    }       
	else
		{
		zaehl_aequivalenzen_towards_input(item_line_p,Fehlerart_out_e);
		break ;
		}
      }
     else
		{
		zaehl_aequivalenzen_towards_input(item_line_p,Fehlerart_out_e);
		break;
		}
				  
  }while ( 0 == 0 ) ;

}

void zaehl_aequivalenzen_towards_input(line_C *line_p, AEQUIVALENZ_TYP Fehlerart_out_e)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_help_out_e; 
line_C  *nachfolger_line_p, *vorgaenger_line_p;

nachfolger_line_p = line_p ;

if (nachfolger_line_p->is_primary_input() == FALSE )
 for (Fehlerart_in_e = Stuck_at_0;Fehlerart_in_e <= Stuck_at_1;Fehlerart_in_e = AEQUIVALENZ_TYP(int(Fehlerart_in_e)+1))
  for( int i =0; i<nachfolger_line_p->vorgaenger()->gib_only_gate()->no_inputs();i++)
   { vorgaenger_line_p = (*nachfolger_line_p->vorgaenger()->gib_only_gate()->gib_inputs())[i];
        if ((*vorgaenger_line_p->nachfolger())[0]->gib_type() != FANOUT )
	    {
	     Fehlerart_help_out_e = out_Aequivalenztyp(vorgaenger_line_p,(*vorgaenger_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if ((Fehlerart_out_e != no_Aequivalenz) && (Fehlerart_help_out_e == Fehlerart_out_e))
	         {
			if ((Fehlerart_in_e == Stuck_at_0) && (vorgaenger_line_p->geprueft_b == FALSE))
				{
				vorgaenger_line_p->geprueft_b = TRUE;
				vorgaenger_line_p->aequiklass_at_0_nr_i = aequivalenzen_zahl_i;
				zaehl_aequivalenzen_towards_input(vorgaenger_line_p,Fehlerart_in_e);
				}
			if ((Fehlerart_in_e == Stuck_at_1) && (vorgaenger_line_p->signal_path_exist_b == FALSE))
				{
				vorgaenger_line_p->signal_path_exist_b = TRUE;
				vorgaenger_line_p->aequiklass_at_1_nr_i = aequivalenzen_zahl_i;
				zaehl_aequivalenzen_towards_input(vorgaenger_line_p,Fehlerart_in_e);
				}
		
		 } //no_aequivalenz
	    } // FANOUT
   } //for
}


/*

// Aufruf forall elemente in Liste der redunanten und aborteten Fehlern vorher diese Liste ermitteln
//alle line_p->geprueft auf FALSE setzen

void zaehl_abort_u_redunant_klassen(line_C *line_p)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_out_e ;
AEQUIVALENZ_TYP  Fehlerart_begin_in_e;
line_C  *item_line_p,*nachfolger_line_p;
boolean begin_b = TRUE;

if (only_stuck_at_test_b == FALSE)
	return;
item_line_p = line_p ;

for (Fehlerart_begin_in_e = Stuck_at_0;Fehlerart_begin_in_e <= Stuck_at_1;Fehlerart_begin_in_e = AEQUIVALENZ_TYP(int(Fehlerart_begin_in_e)+1),item_line_p = line_p,begin_b = TRUE)
if (((Fehlerart_begin_in_e == Stuck_at_0) && (item_line_p->geprueft_b == FALSE)) ||
    ((Fehlerart_begin_in_e == Stuck_at_1) && (item_line_p->signal_path_exist_b == FALSE)))
do
  {
     if (begin_b == TRUE)
             {
	             Fehlerart_in_e = Fehlerart_begin_in_e;
		     if ((Fehlerart_in_e == Stuck_at_0) && (item_line_p->get_s_a_0_aborted() == TRUE))
				{
				aborted_klassen_zahl_i++;
				item_line_p->geprueft_b = TRUE;
				}
				
		     if ((Fehlerart_in_e == Stuck_at_1) && (item_line_p->get_s_a_1_aborted() == TRUE))
				{
				aborted_klassen_zahl_i++;
				item_line_p->signal_path_exist_b = TRUE;
				}
				
		     if ((Fehlerart_in_e == Stuck_at_0) && (item_line_p->get_s_a_0_untestable() == TRUE))
				{
				redundanz_klassen_zahl_i++;
				item_line_p->geprueft_b = TRUE;
				}
				
		     if ((Fehlerart_in_e == Stuck_at_1) && (item_line_p->get_s_a_1_untestable() == TRUE))
				{
				redundanz_klassen_zahl_i++;
				item_line_p->signal_path_exist_b = TRUE;
				}
				
		             begin_b = FALSE;
			     zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_in_e);
	     }

	     
   if (item_line_p->is_primary_output() == FALSE )
      {
        if ((*item_line_p->nachfolger())[0]->gib_type() != FANOUT )
	    {
	     nachfolger_line_p = (*(*item_line_p->nachfolger())[0]->gib_outputs())[0];
	     Fehlerart_out_e = out_Aequivalenztyp(item_line_p,(*item_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if (Fehlerart_out_e != no_Aequivalenz)	     
	         {

			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_0))
				nachfolger_line_p->geprueft_b = TRUE;
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_0))
				nachfolger_line_p->geprueft_b = TRUE;
			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_1))
				nachfolger_line_p->signal_path_exist_b = TRUE;
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_1))
				nachfolger_line_p->signal_path_exist_b = TRUE;

			item_line_p = nachfolger_line_p ;
			zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_out_e);



		  Fehlerart_in_e = Fehlerart_out_e;    
										   
		 }
	       else
		    {
			zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_out_e);
			zaehl_abort_u_redunant_klassen(nachfolger_line_p); //fuer Aequivalenzen tiefer in der Fanoutfreien Zone
			break;
		    }
	    }       
	else
		{
		zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_out_e);
		break ;
		}
      }
     else
		{
		zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_out_e);
		break;
		}
				  
  }while ( 0 == 0 ) ;

}

void zaehl_abort_u_redunant_klassen_towards_input(line_C *line_p , AEQUIVALENZ_TYP Fehlerart_out_e)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_help_out_e ;
line_C  *nachfolger_line_p, *vorgaenger_line_p;

nachfolger_line_p = line_p ;

if (nachfolger_line_p->is_primary_input() == FALSE )
 for (Fehlerart_in_e = Stuck_at_0;Fehlerart_in_e <= Stuck_at_1;Fehlerart_in_e = AEQUIVALENZ_TYP(int(Fehlerart_in_e)+1))
  for( int i =0; i<nachfolger_line_p->vorgaenger()->gib_only_gate()->no_inputs();i++)
   { vorgaenger_line_p = (*nachfolger_line_p->vorgaenger()->gib_only_gate()->gib_inputs())[i];
        if ((*vorgaenger_line_p->nachfolger())[0]->gib_type() != FANOUT )
	    {
	     Fehlerart_help_out_e = out_Aequivalenztyp( vorgaenger_line_p, (*vorgaenger_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if ((Fehlerart_help_out_e != no_Aequivalenz)  && (Fehlerart_help_out_e == Fehlerart_out_e))
	         {
			if (Fehlerart_in_e == Stuck_at_0)
				{
			        vorgaenger_line_p->geprueft_b = TRUE;
				vorgaenger_line_p->aequiklass_at_0_nr_i = aborted_klassen_zahl_i+redundanz_klassen_zahl_i;
				zaehl_abort_u_redunant_klassen_towards_input(vorgaenger_line_p,Fehlerart_in_e);
				}
			if (Fehlerart_in_e == Stuck_at_1)
				{
				vorgaenger_line_p->signal_path_exist_b = TRUE;
				vorgaenger_line_p->aequiklass_at_1_nr_i = aborted_klassen_zahl_i+redundanz_klassen_zahl_i;;
				zaehl_abort_u_redunant_klassen_towards_input(vorgaenger_line_p,Fehlerart_in_e);
				}

											 
		
		 } //no_aequivalenz
	    } // FANOUT
   } //for
}

void gib_redundanz_aborted_klassen_anzahl()
{
//vorerst Stelle fuer Redundanz Klassen Bestimmung Eb!!!30.6 
extern line_liste_C red_abo_liste_C;
line_C *line_item_p;


{forall(line_item_p,lines_C)
        if ((line_item_p->get_s_a_1_aborted() == TRUE) || (line_item_p->get_s_a_0_aborted() == TRUE) ||
	    (line_item_p->get_s_a_1_untestable() == TRUE) || (line_item_p->get_s_a_0_untestable() == TRUE))
		red_abo_liste_C.fuege_ein(line_item_p);}

{forall(line_item_p,lines_C)
	{
	line_item_p->geprueft_b = FALSE;
	line_item_p->signal_path_exist_b = FALSE;
	}}
{forall(line_item_p,red_abo_liste_C)
	zaehl_abort_u_redunant_klassen(line_item_p);}

{forall(line_item_p,lines_C)
	{
	line_item_p->geprueft_b = FALSE;
	line_item_p->signal_path_exist_b = FALSE;
	}}
}
*/


void zaehl_abort_u_redunant_klassen(line_C *line_p , TEST_TYP test_ergebnis_e,AEQUIVALENZ_TYP Fehlerart_begin_in_e)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_out_e ;
line_C  *item_line_p,*nachfolger_line_p;
boolean begin_b = TRUE;
boolean getestet_b = TRUE ;

if (only_stuck_at_test_b == FALSE)
	return;
item_line_p = line_p ;

item_line_p = line_p;
begin_b = TRUE ;
if (((Fehlerart_begin_in_e == Stuck_at_0) && (item_line_p->geprueft_b == FALSE)) ||
    ((Fehlerart_begin_in_e == Stuck_at_1) && (item_line_p->signal_path_exist_b == FALSE)))
do
  {
     if (begin_b == TRUE)
             {
	             Fehlerart_in_e = Fehlerart_begin_in_e;
		     if (test_ergebnis_e == abortet)
			{
			if ((Fehlerart_in_e == Stuck_at_0) && (item_line_p->get_s_a_0_aborted() == TRUE) && (item_line_p->geprueft_b == FALSE))
				{
				aborted_klassen_zahl_i++;
				item_line_p->geprueft_b = TRUE;
				getestet_b = FALSE ;
				}
				
			if ((Fehlerart_in_e == Stuck_at_1) && (item_line_p->get_s_a_1_aborted() == TRUE) && (item_line_p->signal_path_exist_b == FALSE))
				{
				aborted_klassen_zahl_i++;
				item_line_p->signal_path_exist_b = TRUE;
				getestet_b = FALSE ;
				}
			}

		     if (test_ergebnis_e == redundant)
			{
			if ((Fehlerart_in_e == Stuck_at_0) && (item_line_p->get_s_a_0_untestable() == TRUE) && (item_line_p->geprueft_b == FALSE))
				{
				redundanz_klassen_zahl_i++;
				item_line_p->geprueft_b = TRUE;
				getestet_b = FALSE ;
				}
				
			if ((Fehlerart_in_e == Stuck_at_1) && (item_line_p->get_s_a_1_untestable() == TRUE) && (item_line_p->signal_path_exist_b == FALSE))
				{
				redundanz_klassen_zahl_i++;
				item_line_p->signal_path_exist_b = TRUE;
				getestet_b = FALSE ;
				}
			}
		             begin_b = FALSE;
			     if (getestet_b == TRUE)
				break ;
			     zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_in_e);
	     }

	     
   if (item_line_p->is_primary_output() == FALSE )
      {
        if ((*item_line_p->nachfolger())[0]->gib_type() != FANOUT )
	    {
	     nachfolger_line_p = (*(*item_line_p->nachfolger())[0]->gib_outputs())[0];
	     Fehlerart_out_e = out_Aequivalenztyp(item_line_p,(*item_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if (Fehlerart_out_e != no_Aequivalenz)	     
	         {

			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_0))
				nachfolger_line_p->geprueft_b = TRUE;
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_0))
				nachfolger_line_p->geprueft_b = TRUE;
			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_1))
				nachfolger_line_p->signal_path_exist_b = TRUE;
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_1))
				nachfolger_line_p->signal_path_exist_b = TRUE;

			item_line_p = nachfolger_line_p ;
			zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_out_e);



		  Fehlerart_in_e = Fehlerart_out_e;

		 }
	       else
		    {
			zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_in_e);
			zaehl_abort_u_redunant_klassen(nachfolger_line_p,test_ergebnis_e,Stuck_at_0);
			zaehl_abort_u_redunant_klassen(nachfolger_line_p,test_ergebnis_e,Stuck_at_1);
			break;
		    }
	    }       
	else
		{
		zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_in_e);
		break;
		}

      }
     else
		{
		zaehl_abort_u_redunant_klassen_towards_input(item_line_p,Fehlerart_in_e);
		break;
		}
				  
  }while ( 0 == 0 ) ;

}

void zaehl_abort_u_redunant_klassen_towards_input(line_C *line_p , AEQUIVALENZ_TYP Fehlerart_out_e)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_help_out_e ;
line_C  *nachfolger_line_p, *vorgaenger_line_p;

nachfolger_line_p = line_p ;

if (nachfolger_line_p->is_primary_input() == FALSE )
 for (Fehlerart_in_e = Stuck_at_0;Fehlerart_in_e <= Stuck_at_1;Fehlerart_in_e = AEQUIVALENZ_TYP(int(Fehlerart_in_e)+1))
  for( int i =0; i<nachfolger_line_p->vorgaenger()->gib_only_gate()->no_inputs();i++)
   { vorgaenger_line_p = (*nachfolger_line_p->vorgaenger()->gib_only_gate()->gib_inputs())[i];
        if ((*vorgaenger_line_p->nachfolger())[0]->gib_type() != FANOUT)
	    {
	     Fehlerart_help_out_e = out_Aequivalenztyp( vorgaenger_line_p, (*vorgaenger_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if ((Fehlerart_help_out_e != no_Aequivalenz)  && (Fehlerart_help_out_e == Fehlerart_out_e))
	         {
			if (Fehlerart_in_e == Stuck_at_0)
				{
			        vorgaenger_line_p->geprueft_b = TRUE;
				zaehl_abort_u_redunant_klassen_towards_input(vorgaenger_line_p,Fehlerart_in_e);
				}
			if (Fehlerart_in_e == Stuck_at_1)
				{
				vorgaenger_line_p->signal_path_exist_b = TRUE;
				zaehl_abort_u_redunant_klassen_towards_input(vorgaenger_line_p,Fehlerart_in_e);
				}

											 
		
		 } //no_aequivalenz
	    } // FANOUT
   } //for
}

void gib_redundanz_aborted_klassen_anzahl()
{
// vorerst Stelle fuer Redundanz Klassen Bestimmung Eb!!!30.6
extern line_liste_C red_abo_liste_C;
line_C *line_item_p;


{forall(line_item_p,lines_C)
        if ((line_item_p->get_s_a_1_aborted() == TRUE) || (line_item_p->get_s_a_0_aborted() == TRUE) ||
	    (line_item_p->get_s_a_1_untestable() == TRUE) || (line_item_p->get_s_a_0_untestable() == TRUE))
		red_abo_liste_C.fuege_ein(line_item_p);}

{forall(line_item_p,lines_C)
	{
	line_item_p->geprueft_b = FALSE;
	line_item_p->signal_path_exist_b = FALSE;
	}}
{forall(line_item_p,red_abo_liste_C)
	{
	zaehl_abort_u_redunant_klassen(line_item_p,abortet,Stuck_at_0);
	zaehl_abort_u_redunant_klassen(line_item_p,abortet,Stuck_at_1);
	}
}

{forall(line_item_p,lines_C)
	{
	line_item_p->geprueft_b = FALSE;
	line_item_p->signal_path_exist_b = FALSE;
	}}

{forall(line_item_p,lines_C)
	{
	line_item_p->geprueft_b = FALSE;
	line_item_p->signal_path_exist_b = FALSE;
	}}
{forall(line_item_p,red_abo_liste_C)
	{
	zaehl_abort_u_redunant_klassen(line_item_p,redundant,Stuck_at_0);
	zaehl_abort_u_redunant_klassen(line_item_p,redundant,Stuck_at_1);
	}
}

{forall(line_item_p,lines_C)
	{
	line_item_p->geprueft_b = FALSE;
	line_item_p->signal_path_exist_b = FALSE;
	}}
	
//cout << "redundanz abgebrochene Liste" << red_abo_liste_C.no_elements() << "\n"; 	
}

void gib_aequi_klassen_zahl()
// vorerst Stelle zur Berechnung der Aequivalenz Klassenanzahl Eb!!!30.6
{
line_C *linea_item_p;
line_C *lineb_item_p;
line_value_t *linec_item_p;
//line_value_t *zielfault_p;
line_value_t *item_p;
value_t t_e;
int i;
line_value_liste_C zielfehler_a_C;
char *aequi_member_a;

zielfehler_a_C.init(2*(statistic_u.number_lines_i + statistic_u.number_fanout_branches_i));
aequi_member_a = new char[2*(statistic_u.number_lines_i + statistic_u.number_fanout_branches_i)];
for (i=0;i<2*(statistic_u.number_lines_i + statistic_u.number_fanout_branches_i);i++)
   aequi_member_a[i] = 0;
cout << "\tCreate Fault-List\n" << flush;
if ((only_stuck_at_test_b == TRUE) && (stuck_at_test_without_branches_b == FALSE))
{
	erstelle_zielfehlerliste(zielfehler_a_C);
        {forall(linea_item_p,lines_C)
	                {
			linea_item_p->geprueft_b = FALSE;
			linea_item_p->signal_path_exist_b = FALSE;
			}
	}
	{forall(linec_item_p,zielfehler_a_C)
		zaehl_aequivalenzen(linec_item_p->line_p);
	}
	{forall(lineb_item_p,lines_C)
		{
		lineb_item_p->geprueft_b = FALSE;
		lineb_item_p->signal_path_exist_b = FALSE;
		}
	}
{forall(item_p, zielfehler_a_C)
        {       if (item_p->val_e == VAL_0)
                        i = item_p->line_p->gib_aequiklass_at_0_nr_i();
                //else
                if (item_p->val_e == VAL_1)
                        i = item_p->line_p->gib_aequiklass_at_1_nr_i();
		if (aequi_member_a[i] == 0)
	      	   {
		   aequi_member_a[i] = 1;
		   zielfehler_C.fuege_ein(item_p->line_p,item_p->val_e);
		   }//if
//                zielfault_p = zielfehler_C.find_a_aequi_class_member(i);
//                        if (zielfault_p == NULL)
//                                        zielfehler_C.fuege_ein(item_p->line_p,item_p->val_e);
	}}
cout << "\tSort Fault List\n" << flush;
qsort(zielfehler_C.gib_liste(),zielfehler_C.no_elements(),sizeof(line_value_t*),compare_zielfehler);
{forall(linea_item_p,lines_C)
        {
		i = linea_item_p->gib_aequiklass_at_0_nr_i();
		t_e = VAL_0;
		if (aequi_member_a[i] == 0)
		      {
		      aequi_member_a[i] = 1;
		      zielfehler_C.fuege_ein(linea_item_p,t_e);
		      }//if
//		zielfault_p = zielfehler_C.find_a_aequi_class_member(i);
//		if (zielfault_p == NULL)
//			zielfehler_C.fuege_ein(linea_item_p,t_e);

		i = linea_item_p->gib_aequiklass_at_1_nr_i();
		t_e = VAL_1;
		if (aequi_member_a[i] == 0)
		      {
		      aequi_member_a[i] = 1;
		      zielfehler_C.fuege_ein(linea_item_p,t_e);
		      }//if
//	        zielfault_p = zielfehler_C.find_a_aequi_class_member(i);
//		        if (zielfault_p == NULL)
//			                zielfehler_C.fuege_ein(linea_item_p,t_e);
		}}//forall
}
else if (path_delay_test_b == FALSE)
	{
	erstelle_zielfehlerliste(zielfehler_C);
	cout << "\tSort Fault List\n" << flush;
	qsort(zielfehler_C.gib_liste(),zielfehler_C.no_elements(),sizeof(line_value_t*),compare_zielfehler);
	}
delete[] aequi_member_a;
}

void ziel_F_append()
{
int i;
value_t t_e;
line_C *item_p;
line_value_t *zielfault_p;

{forall(item_p,lines_C)
        {
		i = item_p->gib_aequiklass_at_0_nr_i();
		t_e = VAL_0;
		zielfault_p = zielfehler_C.find_a_aequi_class_member(i);
		if (zielfault_p == NULL)
			zielfehler_C.fuege_ein(item_p,t_e);

		i = item_p->gib_aequiklass_at_1_nr_i();
		t_e = VAL_1;
	        zielfault_p = zielfehler_C.find_a_aequi_class_member(i);
		        if (zielfault_p == NULL)
			                zielfehler_C.fuege_ein(item_p,t_e);
	}

}
}

// mark_all markieren der getesteten Fehler ueber dominanz und aequivalenz
void mark_all(line_C *line_p,AEQUIVALENZ_TYP Fehlerart_begin_in_e)
{
AEQUIVALENZ_TYP  Fehlerart_in_e, Fehlerart_out_e ;
line_C  *item_line_p,*nachfolger_line_p;

if ((only_stuck_at_test_b == FALSE) || (flt_read_b == TRUE))
	return;
item_line_p = line_p ;
boolean begin_b = TRUE ;
boolean dummy1_b;
boolean dummy2_b;
//line_C *dominator_p; //neu
//value_t tval_e;
//AEQUIVALENZ_TYP test_e;

do
  {
     if (begin_b == TRUE)
             {
		Fehlerart_in_e = Fehlerart_begin_in_e;
		begin_b = FALSE;
		mark_aequivalenzen_towards_input(item_line_p);
	     }

	     
   if (item_line_p->is_primary_output() == FALSE )
      {
        if ((*item_line_p->nachfolger())[0]->gib_type() != FANOUT )
	    {//!= Fanout
	     nachfolger_line_p = (*(*item_line_p->nachfolger())[0]->gib_outputs())[0];
	     Fehlerart_out_e = out_Aequivalenztyp(item_line_p, (*item_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	     if (Fehlerart_out_e != no_Aequivalenz)	     
	         {
			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_0))
				{
				if (nachfolger_line_p->get_s_a_0_test() == TRUE) break;
				if (nachfolger_line_p->get_s_a_0_untestable() == TRUE) break;
				if ((item_line_p->get_s_a_0_aborted() == TRUE) || (item_line_p->get_s_a_0_untestable() == TRUE))
					{
					nachfolger_line_p->set_s_a_0_aborted(item_line_p->get_s_a_0_aborted());
					if (item_line_p->get_s_a_0_untestable() == TRUE)
						{
						nachfolger_line_p->set_s_a_0_untestable();
						dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
							if (dummy1_b == TRUE)
								{
								dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
								if (dummy2_b == FALSE)
									hilf_C.fuege_ein(nachfolger_line_p, VAL_0);
								}	
						}
					}
						
				if (item_line_p->get_s_a_0_test() == TRUE)
					{
					nachfolger_line_p->set_s_a_0_test();
					nachfolger_line_p->set_s_a_0_aborted(FALSE);
					dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
					if (dummy1_b == TRUE)
						{
						dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
						if (dummy2_b == FALSE)
							hilf_C.fuege_ein(nachfolger_line_p, VAL_0);
						}						
					if (nachfolger_line_p->get_s_a_1_test() == TRUE)
						{
						nachfolger_line_p->set_stuck_at_test();
						if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
							((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
								nachfolger_line_p->set_test_done();
						}//if
					}
				}
				
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_0))
				{
				if (nachfolger_line_p->get_s_a_0_test()) break ;
				if (nachfolger_line_p->get_s_a_0_untestable() == TRUE) break;
				if ((item_line_p->get_s_a_1_aborted() == TRUE) || (item_line_p->get_s_a_1_untestable() == TRUE))
					{
					nachfolger_line_p->set_s_a_0_aborted(item_line_p->get_s_a_1_aborted()) ;
					if (item_line_p->get_s_a_1_untestable() == TRUE)
						{
						nachfolger_line_p->set_s_a_0_untestable();
						dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
						if (dummy1_b == TRUE)
							{
							dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
							if (dummy2_b == FALSE)
								hilf_C.fuege_ein(nachfolger_line_p, VAL_0);
							}
						}
					}
				if (item_line_p->get_s_a_1_test() == TRUE)
					{
					nachfolger_line_p->set_s_a_0_test();
					nachfolger_line_p->set_s_a_0_aborted(FALSE);
					dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
					if (dummy1_b == TRUE)
						{
						dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
						if (dummy2_b == FALSE)
							hilf_C.fuege_ein(nachfolger_line_p, VAL_0);
						}						
					if (nachfolger_line_p->get_s_a_1_test() == TRUE)
						{
						nachfolger_line_p->set_stuck_at_test();
						if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
							((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
								nachfolger_line_p->set_test_done();
						}//if
					}
				}

			if ((Fehlerart_in_e == Stuck_at_0) && (Fehlerart_out_e == Stuck_at_1))
				{
				if (nachfolger_line_p->get_s_a_1_test()) break ;
				if (nachfolger_line_p->get_s_a_1_untestable() == TRUE) break ;
				if ((item_line_p->get_s_a_0_aborted() == TRUE) || (item_line_p->get_s_a_0_untestable() == TRUE))
					{
					nachfolger_line_p->set_s_a_1_aborted(item_line_p->get_s_a_0_aborted());
					if (item_line_p->get_s_a_0_untestable() == TRUE)
						{
						nachfolger_line_p->set_s_a_1_untestable();
						dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
						if (dummy1_b == TRUE)
							{
							dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
							if (dummy2_b == FALSE)
								hilf_C.fuege_ein(nachfolger_line_p, VAL_1);
							}
						}
					}
				if (item_line_p->get_s_a_0_test() == TRUE)
					{
					nachfolger_line_p->set_s_a_1_test();
					nachfolger_line_p->set_s_a_1_aborted(FALSE);
					dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
					if (dummy1_b == TRUE)
						{
						dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
						if (dummy2_b == FALSE)
							hilf_C.fuege_ein(nachfolger_line_p, VAL_1);
						}						
					if (nachfolger_line_p->get_s_a_0_test() == TRUE)
						{
						nachfolger_line_p->set_stuck_at_test();
						if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
								((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
									nachfolger_line_p->set_test_done();
						}//if
					}
				}
				
			if ((Fehlerart_in_e == Stuck_at_1) && (Fehlerart_out_e == Stuck_at_1))
				{
				if (nachfolger_line_p->get_s_a_1_test()) break ;
				if (nachfolger_line_p->get_s_a_1_untestable() == TRUE) break ;
				if ((item_line_p->get_s_a_1_aborted() == TRUE) || (item_line_p->get_s_a_1_untestable() == TRUE))
					{
					nachfolger_line_p->set_s_a_1_aborted(item_line_p->get_s_a_1_aborted());
					if (item_line_p->get_s_a_1_untestable() == TRUE)
						{
						nachfolger_line_p->set_s_a_1_untestable(); // Uwes get was here bad man
						dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
						if (dummy1_b == TRUE)
							{
							dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
							if (dummy2_b == FALSE)
								hilf_C.fuege_ein(nachfolger_line_p, VAL_1);
							}
						}
					}
				if (item_line_p->get_s_a_1_test() == TRUE)
					{
					nachfolger_line_p->set_s_a_1_test();
					nachfolger_line_p->set_s_a_1_aborted(FALSE);
					dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
					if (dummy1_b == TRUE)
						{
						dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
						if (dummy2_b == FALSE)
							hilf_C.fuege_ein(nachfolger_line_p, VAL_1);
						}						
					if (nachfolger_line_p->get_s_a_0_test() == TRUE)
						{
						nachfolger_line_p->set_stuck_at_test();
						if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
							((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
								nachfolger_line_p->set_test_done();
						}//if
					}
				}

			item_line_p = nachfolger_line_p ;
			mark_aequivalenzen_towards_input(item_line_p);



		  Fehlerart_in_e = Fehlerart_out_e;    
										   
		 }
	       else
		    {
			mark_aequivalenzen_towards_input(item_line_p);
			// ******* Fuer den Fall einer Dominanzbeziehung ******************
			// *******  (Fehlerart_out_e == no_Aequivalenz)  *****************
			
// *** 1. redundant 
					
if ((item_line_p->get_s_a_1_untestable() == TRUE) && (Fehlerart_in_e == Stuck_at_1))
	{
	Fehlerart_out_e = out_Dominanztyp(item_line_p,(*item_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	if (Fehlerart_out_e == Stuck_at_1)
		if (zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1) == FALSE)
			if ((nachfolger_line_p->get_s_a_1_untestable() == FALSE) && (nachfolger_line_p->get_s_a_1_test() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE))
			    zielfehler_C.fuege_ein(nachfolger_line_p,VAL_1,FALSE);

	if (Fehlerart_out_e == Stuck_at_0)
		if (zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0) == FALSE)
			if ((nachfolger_line_p->get_s_a_0_untestable() == FALSE) && (nachfolger_line_p->get_s_a_0_test() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE) && (nachfolger_line_p->get_s_a_0_aborted() == FALSE))
			    zielfehler_C.fuege_ein(nachfolger_line_p,VAL_0,FALSE);
	}

if ((item_line_p->get_s_a_0_untestable() == TRUE) && (Fehlerart_in_e == Stuck_at_0))
	{
	Fehlerart_out_e = out_Dominanztyp(item_line_p,(*item_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
	if (Fehlerart_out_e == Stuck_at_1)
		if (zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1) == FALSE)
			if ((nachfolger_line_p->get_s_a_1_untestable() == FALSE) && (nachfolger_line_p->get_s_a_1_test() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE))
			    zielfehler_C.fuege_ein(nachfolger_line_p,VAL_1,FALSE);

	if (Fehlerart_out_e == Stuck_at_0)
		if (zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0) == FALSE)
			if ((nachfolger_line_p->get_s_a_0_untestable() == FALSE) && (nachfolger_line_p->get_s_a_0_test() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE) && (nachfolger_line_p->get_s_a_0_aborted() == FALSE))
			    zielfehler_C.fuege_ein(nachfolger_line_p,VAL_0,FALSE);
	}


// ***************************************************************************************************
				
// *** 2. es gab einen Test aborted				

			if ((((item_line_p->get_s_a_1_untestable() == TRUE) && (Fehlerart_in_e == Stuck_at_1)) ||
			   ((item_line_p->get_s_a_0_untestable() == TRUE) && (Fehlerart_in_e == Stuck_at_0))) == FALSE)
			{
						
			Fehlerart_out_e = out_Dominanztyp(item_line_p,(*item_line_p->nachfolger())[0]->gib_type() , Fehlerart_in_e ) ;
			if ((Fehlerart_out_e == Stuck_at_0) || (Fehlerart_out_e == Stuck_at_1))
				{
				
				if (Fehlerart_out_e == Stuck_at_0 && Fehlerart_in_e == Stuck_at_0)
					{
					if ((item_line_p->get_s_a_0_test() == TRUE) && (nachfolger_line_p->get_s_a_0_test() == FALSE))
						{
						nachfolger_line_p->set_s_a_0_test();
						nachfolger_line_p->set_s_a_0_aborted(FALSE);
						dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
						if (dummy1_b == TRUE)
							{
							dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
							if (dummy2_b == FALSE)
								hilf_C.fuege_ein(nachfolger_line_p, VAL_0);
							}							
						if (nachfolger_line_p->get_s_a_1_test() == TRUE)
							{
							nachfolger_line_p->set_stuck_at_test();
							if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
							   ((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
								nachfolger_line_p->set_test_done();
							}//if
						}

					if ((item_line_p->get_s_a_0_aborted() == TRUE) && (nachfolger_line_p->get_s_a_0_test() == FALSE)
					    && (nachfolger_line_p->get_s_a_0_untestable() == FALSE) && (nachfolger_line_p->get_s_a_0_aborted() == FALSE))

							nachfolger_line_p->set_s_a_0_aborted(TRUE);

					item_line_p = nachfolger_line_p ;
					}
					
				if (Fehlerart_out_e == Stuck_at_1 && Fehlerart_in_e == Stuck_at_0)   
					{
					if ((item_line_p->get_s_a_0_test() == TRUE) && (nachfolger_line_p->get_s_a_1_test() == FALSE))
						{
						nachfolger_line_p->set_s_a_1_test();
						nachfolger_line_p->set_s_a_1_aborted(FALSE);
						dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
						if (dummy1_b == TRUE)
							{
							dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
							if (dummy2_b == FALSE)
								hilf_C.fuege_ein(nachfolger_line_p, VAL_1);
							}										    
						if (nachfolger_line_p->get_s_a_0_test() == TRUE)
							{
							nachfolger_line_p->set_stuck_at_test();
							if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
							   ((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
								nachfolger_line_p->set_test_done();
							}//if
						}
			
					if ((item_line_p->get_s_a_0_aborted() == TRUE) && (nachfolger_line_p->get_s_a_1_test() == FALSE)
					    && (nachfolger_line_p->get_s_a_1_untestable() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE))
						
							nachfolger_line_p->set_s_a_1_aborted(TRUE);

					item_line_p = nachfolger_line_p ;
			
					}
					
					if (Fehlerart_out_e == Stuck_at_0 && Fehlerart_in_e == Stuck_at_1)
						{
						if ((item_line_p->get_s_a_1_test() == TRUE) && (nachfolger_line_p->get_s_a_0_test() == FALSE))
							{
							nachfolger_line_p->set_s_a_0_test();
							nachfolger_line_p->set_s_a_0_aborted(FALSE);
							dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
							if (dummy1_b == TRUE)
								{
								dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_0,FALSE);
								if (dummy2_b == FALSE)
								hilf_C.fuege_ein(nachfolger_line_p, VAL_0);
								}		    
							if (nachfolger_line_p->get_s_a_1_test() == TRUE)
								{
								nachfolger_line_p->set_stuck_at_test();
								if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
								    ((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
									nachfolger_line_p->set_test_done();
								}//if
							}
						if ((item_line_p->get_s_a_1_aborted() == TRUE) && (nachfolger_line_p->get_s_a_0_test() == FALSE)
						    && (nachfolger_line_p->get_s_a_0_untestable() == FALSE) && (nachfolger_line_p->get_s_a_0_aborted() == FALSE))

								nachfolger_line_p->set_s_a_0_aborted(TRUE);
	
						item_line_p = nachfolger_line_p ;
						}
						
					if (Fehlerart_out_e == Stuck_at_1 && Fehlerart_in_e == Stuck_at_1 )   
						{

						if ((item_line_p->get_s_a_1_test() == TRUE) && (nachfolger_line_p->get_s_a_1_test() == FALSE))
							{
							nachfolger_line_p->set_s_a_1_test();
							nachfolger_line_p->set_s_a_1_aborted(FALSE);
							dummy1_b = zielfehler_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
							if (dummy1_b == TRUE)
								{
								dummy2_b = hilf_C.element_in_liste(nachfolger_line_p,VAL_1,FALSE);
								if (dummy2_b == FALSE)
									hilf_C.fuege_ein(nachfolger_line_p, VAL_1);
								}
							if (nachfolger_line_p->get_s_a_0_test() == TRUE)
								{
								nachfolger_line_p->set_stuck_at_test();
								if ((only_stuck_at_test_b == TRUE) && ((nachfolger_line_p->is_primary_input() == TRUE) ||
								   ((*nachfolger_line_p->vorgaenger())[0]->gib_type() != BLOCK)))
									nachfolger_line_p->set_test_done();
								}//if
							}
						if ((item_line_p->get_s_a_1_aborted() == TRUE) && (nachfolger_line_p->get_s_a_1_test() == FALSE)
						    && (nachfolger_line_p->get_s_a_1_untestable() == FALSE) && (nachfolger_line_p->get_s_a_1_aborted() == FALSE))

							nachfolger_line_p->set_s_a_1_aborted(TRUE);

						item_line_p = nachfolger_line_p ;

						}
				Fehlerart_in_e = Fehlerart_out_e;      
										   
			
				mark_all(item_line_p,Fehlerart_in_e); //fuer Aequivalenzen und Dominanzen tiefer in der Fanoutfreien Zone
				}
			// *****************************************************************
			}
			break;
		    }
	    }
	else
		{
		mark_aequivalenzen_towards_input(item_line_p);
		// neu **********************************
/*
		dominator_p = item_line_p->get_static_dominator();
		if (dominator_p != NULL)
		  {
		  tval_e = dominator_p->get_good_value();
		  if ((tval_e == VAL_1) || (tval_e == VAL_D) || (tval_e == VAL_1S))
			{
			dominator_p->set_s_a_0_test();
			dominator_p->set_s_a_0_aborted(FALSE);
			test_e = Stuck_at_0 ;
			}
		  if ((tval_e == VAL_0) || (tval_e == VAL_D_BAR) || (tval_e == VAL_0S))
			{
			test_e = Stuck_at_1 ;
			dominator_p->set_s_a_1_test();
			dominator_p->set_s_a_1_aborted(FALSE);
			}
		  mark_all(dominator_p,test_e);
			
		  }
*/		  
		// neu Ende *****************************
		break ;
		}
      }
     else
		{
		mark_aequivalenzen_towards_input(item_line_p);
		break;
		}
				  
  }while ( 0 == 0 ) ;

}




dominanz_result_t dominanz(gate_C *gate_p)
{
dominanz_result_t ergebnis_b ;
AEQUIVALENZ_TYP beziehung_e;
line_C *vorgaenger_line_p;
value_t testvalue_e;

ergebnis_b.VAL_0_b = TRUE ;
ergebnis_b.VAL_1_b = TRUE ;

for (testvalue_e = VAL_0; testvalue_e < VAL_1; testvalue_e = value_t(int(testvalue_e)+1))
  for( int i =0; i<gate_p->no_inputs();i++)
     { vorgaenger_line_p = (*gate_p->gib_inputs())[i];
		beziehung_e = suche_nach_Dominanz(vorgaenger_line_p, testvalue_e );
		if ((beziehung_e == no_Dominanz) && (testvalue_e == VAL_0)) ergebnis_b.VAL_1_b = FALSE;
		if ((beziehung_e == no_Dominanz) && (testvalue_e == VAL_1)) ergebnis_b.VAL_0_b = FALSE;
     }
return ergebnis_b;

}


AEQUIVALENZ_TYP suche_nach_Dominanz(line_C *vorgaenger_line_p, value_t testvalue_e )
{
cube_list_t cube_0_array;
cube_list_t cube_1_array;
cube_list_t *cube_0_array_p;
cube_list_t *cube_1_array_p;
have_test_result_t result_1_c;
have_test_result_t result_0_c;
gate_C *gate_item_p;
int i=0;
boolean test_1 = FALSE;
boolean test_0 = FALSE;

gate_item_p = (*vorgaenger_line_p->nachfolger())[0];
cube_0_array = *gate_item_p->gib_cubes(VAL_0);
cube_1_array = *gate_item_p->gib_cubes(VAL_1);
cube_0_array_p = &cube_0_array;
cube_1_array_p = &cube_1_array;

//print_cubes(gate_item_p, cube_0_array_p, cube_1_array_p,1);
for (i=0 ; i < gate_item_p->no_inputs(); i++)
if (vorgaenger_line_p->gib_number() == (*gate_item_p->gib_inputs())[i]->gib_number()) break;

// i == Position des Gate_input_s in der Cuben-Zeile

if ( cube_0_array_p  != NULL )
	{
	result_1_c = have_test(cube_0_array_p,cube_0_array_p,i,testvalue_e,cube_1_array_p);
	test_1 = result_1_c.beziehung_b;
	}
	
if ( cube_1_array_p  != NULL)
	{
	result_0_c = have_test(cube_1_array_p,cube_1_array_p,i,testvalue_e,cube_0_array_p);
	test_0 = result_0_c.beziehung_b;
	}

if (((test_1 == FALSE) && (test_0 == FALSE))  || ((test_1 == TRUE) && (test_0 == TRUE)) /* voellig undef Gatter*/ )
	return no_Dominanz;
else
	if (test_1 == TRUE)
		return Stuck_at_1;
	else if (test_0== TRUE)
		return Stuck_at_0;
	
}


have_test_result_t have_test( cube_list_t *test_zeile_p, cube_list_t *cube_array_p, int i, value_t testvalue_e, cube_list_t *other_cube_p)
{
cube_list_t *zeile_p;
cube_list_t *vergleich_zeile_p;
have_test_result_t ergebnis_c;
belegung_t *beleg_p;
value_t invert_testvalue_e;
int j=0;
boolean test_b = FALSE;
boolean gleich_b ;

if (testvalue_e == VAL_1)
	invert_testvalue_e = VAL_0;
else
	invert_testvalue_e = VAL_1;

for ( zeile_p = test_zeile_p; zeile_p != NULL  ; zeile_p = zeile_p->next_p)
        {
	for ( beleg_p = zeile_p->to_belegung_p , j =0 ;((beleg_p != NULL) && ( j<i )) ; j++ )
			beleg_p = beleg_p->next_p ;

	if (( beleg_p->val_e == testvalue_e ) && ( test_b == FALSE))
		{
			test_zeile_p = zeile_p;
			test_b = TRUE;
			break;
		}
	}

if ( test_b == TRUE )
	{ 
	for ( zeile_p = cube_array_p ;zeile_p != NULL  ; zeile_p = zeile_p->next_p)
		{
		if (zeile_p != test_zeile_p)
			{
			for ( beleg_p = zeile_p->to_belegung_p , j=0 ; ((beleg_p != NULL) && ( j<i )) ; j++ )
				beleg_p = beleg_p->next_p ;
				
			if (( beleg_p->val_e == invert_testvalue_e ) || ( beleg_p->val_e == VAL_X))
				{
				vergleich_zeile_p = zeile_p;
				gleich_b = vergleiche(vergleich_zeile_p ,test_zeile_p,i);
				if (gleich_b == TRUE) 
					{
						test_b = FALSE;
						if (test_zeile_p->next_p != NULL)
							{
							ergebnis_c = have_test(test_zeile_p->next_p,cube_array_p,i,testvalue_e,other_cube_p);
							test_b = ergebnis_c.beziehung_b;
							}
						break;
					}
				}
			}
		}//for
	}
// nur fuer komplexgatter mit undefinierten Ausgangsbelegungen
if (test_b == TRUE )
	{
	gleich_b = vergleiche(test_zeile_p, other_cube_p);
                        if (gleich_b == TRUE) 
				{
				test_zeile_p = NULL;
				test_b = FALSE;
				if (test_zeile_p->next_p != NULL)
					{
					ergebnis_c = have_test(test_zeile_p->next_p,cube_array_p,i,testvalue_e,other_cube_p);
					test_b = ergebnis_c.beziehung_b;
					}
				}
	}
ergebnis_c.beziehung_b =test_b;
ergebnis_c.zeile_p = test_zeile_p;
return ergebnis_c;
}

AEQUIVALENZ_TYP suche_nach_Aequivalenz(line_C* vorgaenger_line_p, value_t testvalue_e )
{

cube_list_t cube_0_array;
cube_list_t cube_1_array;
cube_list_t *cube_0_array_p;
cube_list_t *cube_1_array_p;
gate_C *gate_item_p;
int i=0;
boolean aequivalenz_1 = FALSE;
boolean aequivalenz_0 = FALSE;

gate_item_p = (*vorgaenger_line_p->nachfolger())[0];

/*if ((suche_nach_Dominanz(vorgaenger_line_p, testvalue_e ) == Stuck_at_1) ||
    (suche_nach_Dominanz( vorgaenger_line_p, testvalue_e ) == Stuck_at_0))
    {  */  

	cube_0_array = *gate_item_p->gib_cubes(VAL_0);
	cube_1_array = *gate_item_p->gib_cubes(VAL_1);
	cube_0_array_p = &cube_0_array;
	cube_1_array_p = &cube_1_array;
//print_cubes(gate_item_p, cube_0_array_p, cube_1_array_p,2);
	for (i=0 ; i < gate_item_p->no_inputs(); i++)
		if (vorgaenger_line_p->gib_number() == (*gate_item_p->gib_inputs())[i]->gib_number()) break;


	// i == Position des Gate_input_s in der Cuben-Zeile
	
	
	if ( cube_0_array_p  != NULL )
		aequivalenz_1 = no_more_test(cube_0_array_p,cube_0_array_p,i,testvalue_e,cube_1_array_p);

	if ( cube_1_array_p  != NULL)
		aequivalenz_0 = no_more_test(cube_1_array_p,cube_1_array_p,i,testvalue_e,cube_0_array_p);

	if ((aequivalenz_1 == FALSE) && (aequivalenz_0 == FALSE))
//  || ((test_1 == TRUE) && (test_0 == TRUE)) voellig undef Gatter noch nicht betrachtet
		return no_Aequivalenz;
	else
		if (aequivalenz_1 == TRUE)
			return Stuck_at_1;
		else if (aequivalenz_0== TRUE) 
			return Stuck_at_0;

			
/*
    }
else return no_Aequivalenz;
*/
}

boolean more_out_put_test( cube_list_t *test_zeile_p,cube_list_t *cube_array_p, int i, value_t testvalue_e, cube_list_t *other_cube_p)
{
cube_list_t *zeile_p ;
cube_list_t *vergleich_zeile_p ;

belegung_t *beleg_p ;
value_t invert_testvalue_e;
int j=0 ;
boolean aequiva_b = TRUE ;
boolean gleich_b;
boolean test_b = FALSE;
boolean second_test_b = FALSE;

if (testvalue_e == VAL_1)
	invert_testvalue_e = VAL_0;
else
	invert_testvalue_e = VAL_1;

for ( zeile_p = cube_array_p; ((zeile_p != NULL) && ( aequiva_b == TRUE))  ; zeile_p = zeile_p->next_p)
        {
	 for ( beleg_p = zeile_p->to_belegung_p , j =0 ;((beleg_p != NULL) && ( j<i )) ; j++ )
		beleg_p = beleg_p->next_p ;

	if ( beleg_p->val_e == VAL_X)
		{
		aequiva_b = FALSE;
		break;
		}

	if (( beleg_p->val_e == testvalue_e ) && ( test_zeile_p == NULL ))
		{
			test_zeile_p = zeile_p;
			test_b =TRUE;
			break;
		}
	}

if (( test_b == TRUE ) && (aequiva_b == TRUE))
	{
	for ( zeile_p = cube_array_p ;((zeile_p != NULL) && ( aequiva_b == TRUE)) ; zeile_p = zeile_p->next_p)
		{
		for ( beleg_p = zeile_p->to_belegung_p , j=0 ; ((beleg_p != NULL) && ( j<i )) ; j++ )
			beleg_p = beleg_p->next_p ;
		if (( beleg_p->val_e == invert_testvalue_e ) || (beleg_p->val_e == VAL_X))
			{
			if (beleg_p->val_e == VAL_X)
				{
				aequiva_b = FALSE;
				break;
				}
				
                        vergleich_zeile_p = zeile_p;
			gleich_b = vergleiche(vergleich_zeile_p ,test_zeile_p,i);
                        if (gleich_b == TRUE) 
				{
				test_b = FALSE;
				if (zeile_p->next_p != NULL)
					test_b = more_out_put_test(zeile_p->next_p,cube_array_p,i,testvalue_e,other_cube_p);
				break;
				}
			}
		}
	}
// nur fuer komplexgatter mit undefinierten Ausgangsbelegungen

if ((test_b == TRUE) && (aequiva_b == TRUE ))
	{
	gleich_b = vergleiche(test_zeile_p, other_cube_p);
                        if (gleich_b == TRUE) 
				{
				test_zeile_p = NULL;
				test_b = FALSE;
				if (zeile_p->next_p != NULL)
					test_b = more_out_put_test(zeile_p->next_p,cube_array_p,i,testvalue_e,other_cube_p);
				}
	}





if ((aequiva_b == TRUE ) && (zeile_p != NULL) && (test_zeile_p != NULL))
	{
	gleich_b = vergleiche(test_zeile_p, other_cube_p);
                        if (gleich_b == TRUE) 
				{
				test_zeile_p = NULL;
				aequiva_b = FALSE;
				}
	}
// ************************************************


return aequiva_b ;
}



boolean vergleiche (cube_list_t *vergleich_zeile_p ,cube_list_t *test_zeile_p,int i)
{
// impliziete Annahme alle Cuben zeilen sinb gleich lang
belegung_t *list_1_p;
belegung_t *list_2_p;
int j = 0;
boolean ergbnis_b = TRUE;

list_2_p = test_zeile_p->to_belegung_p;
 for ( list_1_p = vergleich_zeile_p->to_belegung_p ;list_1_p != NULL ;
      list_1_p = list_1_p->next_p, list_2_p = list_2_p->next_p, j++ )
		if (list_1_p->val_e != list_2_p->val_e)
			if ((!(list_1_p->val_e != VAL_X)) && (!(list_2_p->val_e != VAL_X)) && (j != i))
				{
				ergbnis_b = FALSE;
				break;
				}
return ergbnis_b;		
		
}

boolean vergleiche(cube_list_t *test_zeile_p,cube_list_t *other_cube_p)
{
cube_list_t *zeile_p;
belegung_t *list_1_p;
belegung_t *list_2_p;
boolean ergbnis_b = FALSE;

list_2_p = test_zeile_p->to_belegung_p;
for ( zeile_p = other_cube_p; zeile_p != NULL  ; zeile_p = zeile_p->next_p , list_2_p = test_zeile_p->to_belegung_p)
        {
	for ( list_1_p = zeile_p->to_belegung_p ;list_1_p != NULL ;
	      list_1_p = list_1_p->next_p, list_2_p = list_2_p->next_p, ergbnis_b = TRUE)

	      
		if (list_1_p->val_e != list_2_p->val_e)
			if ((list_1_p->val_e != VAL_X) && (list_2_p->val_e != VAL_X))
				{
				ergbnis_b = FALSE;
				break;
				}	
	if (ergbnis_b == TRUE) break;
	

	}
return ergbnis_b;	
}

void print_cubes(gate_C *gate_item_p, cube_list_t *cube_0_array_p,cube_list_t *cube_1_array_p,int art)
{
string_C  name;
cube_list_t *zeile_p;
belegung_t *belegung_p;

if (art ==1)
	cout << "Dominanz    " << flush;
else
	cout << "Aequivalenz " << flush;
name = gate_item_p->get_name();
cout << name;
cout << " \n" << flush;
cout << "Null-cube : \n"<< flush;
for ( zeile_p = cube_0_array_p; zeile_p != NULL  ; zeile_p = zeile_p->next_p )
        {
	for ( belegung_p = zeile_p->to_belegung_p ;belegung_p != NULL ;belegung_p = belegung_p->next_p)
		cout << belegung_p->val_e << flush;
		
	cout << " \n" << flush;
	}
cout << "Eins-cube : \n" << flush;
for ( zeile_p = cube_1_array_p; zeile_p != NULL  ; zeile_p = zeile_p->next_p )
        {
	for ( belegung_p = zeile_p->to_belegung_p ;belegung_p != NULL ;belegung_p = belegung_p->next_p)
		cout << belegung_p->val_e << flush;
		
	cout << " \n" << flush;
	}
}

boolean no_more_test( cube_list_t *test_zeile_p,cube_list_t *cube_array_p, int i, value_t testvalue_e, cube_list_t *other_cube_p)
{
boolean aequiva_b = TRUE ;
int j;
have_test_result_t result_c;
cube_list_t *zeile_p ;
belegung_t *beleg_p ;


for ( zeile_p = cube_array_p; ((zeile_p != NULL) && ( aequiva_b == TRUE))  ; zeile_p = zeile_p->next_p)
        {
	 for ( beleg_p = zeile_p->to_belegung_p , j =0 ;((beleg_p != NULL) && ( j<i )) ; j++ )
		beleg_p = beleg_p->next_p ;

	if ( beleg_p->val_e == VAL_X)
		{
		aequiva_b = FALSE;
		break;
		}
	}
if ((aequiva_b == TRUE) && (cube_array_p != NULL))
	{
	result_c = have_test(test_zeile_p,cube_array_p,i,testvalue_e,other_cube_p);
	if (result_c.beziehung_b == FALSE)
		aequiva_b = FALSE;
	else
		//if (result_c.beziehung_b == TRUE)
		{
		result_c = have_test(result_c.zeile_p->next_p,cube_array_p,i,testvalue_e,other_cube_p);
		if (result_c.beziehung_b == TRUE)
			aequiva_b = FALSE;
		}
	}
return aequiva_b;	
}
