#ifndef line_line_liste_C_h
#define line_line_liste_C_h
#include "liste_C.h"

class line_line_C {
public:
   line_line_C(){line1_p=NULL;line2_p=NULL;test_info_c=0;}
   ~line_line_C(){}
   void set_tested(){test_info_c = 1;}
   void set_aborted(){test_info_c = 2;}
   void reset_aborted(){test_info_c = 0;}
   void set_redundant(){test_info_c = 3;}
   boolean is_tested(){return((test_info_c == 1)?TRUE:FALSE);}
   boolean is_aborted(){return((test_info_c == 2)?TRUE:FALSE);}
   boolean is_redundant(){return((test_info_c == 3)?TRUE:FALSE);}
   boolean test_required(){return((test_info_c == 0)?TRUE:FALSE);}
   line_C *line1_p;
   line_C *line2_p;
private:
   unsigned char test_info_c;
   //boolean test_aborted_b;  //      muss noch in die struct eingefuegt werden
};

class line_line_liste_C: public liste_C, public line_line_C{
public:
   line_line_liste_C(){liste_a = NULL;}
   void init(int size_i);
   ~line_line_liste_C(){if (liste_a != NULL) delete[] liste_a;}
   line_line_C *operator [] (int i){return(liste_a[i]);}
   line_line_C **gib_liste(){return(liste_a);}
   void fuege_ein(line_C *,line_C *);
//   void fuege_aus(line_C *,line_C *);
//   boolean element_in_liste(line_C *,line_C *,boolean = FALSE);
private:
   line_line_C **liste_a;  // Liste mit Lines, die an den aktuellen Block
			    // angeschlossen sind.
};
#endif


