#ifndef object_C_h
#define object_C_h
#include "string_C.h"

//*********************************************************************
//
//   CLASS-NAME: object_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Objekte (Gates, Lines) und
//	alle notwendigen Operationen auf Objekten.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: Konstruktor mit char* Argument: Name des Objektes
//		 Destruktor loescht Objekt
//		 get_name(): gibt den Namen des Objektes aus
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class object_C {
public:
   object_C(char *objectname_sC);
   ~object_C(){delete[] name_sC;}
   char *get_name(){return (name_sC);}
   inline void set_reconvergence(){reconvergence_b = TRUE;}
   inline boolean get_reconvergence(){return(reconvergence_b);}
protected:
   char *name_sC; // 0 statt stringsize_i muesste auch gehen
   object_t object_type_e;
   boolean reconvergence_b; // Rekonvergenz hier
};
#endif
