#ifndef prot_h
#define prot_h

//*********************************************************************
//
//   FILE-NAME: prot.h
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet Funktions Prototypen
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class string_C;
class object_C;
class liste_C;
class stringliste_C;
class gate_liste_C;
class line_liste_C;

extern void error(string_C);
extern void warning(string_C);
extern void print_all();
extern int power(int,int);
extern void print_statistic();
extern "C"{
	void init_ctest();
	void generate_disim(char *,int *);
	void generate_cir(char *,int *);
	void get_d_cubes(int *,int *,ctest_cube_list_t **);
	void get_cubes(int *,int *,int *,ctest_cube_list_t **);
	void reject(int *,int *,int *);
	void generate_test(int *,int *,int *,int *,ctest_belegung_t **,int *);
	void expandmac(char*,int*);
	void select_instance(int*,int*);
	void put_constraints(int *,int *,ctest_cube_list_t **);
	void set_test_reject_level(int *,int *);
	void simulate_pattern(int *,int *,int *,ctest_belegung_t **,ctest_belegung_t **);
	void print_mixed_statistic(int *);
	void get_statistics(int*,int*,int*);
};
#endif



