#ifndef stringliste_C_h
#define stringliste_C_h
#include "string_C.h"

//*********************************************************************
//
//   CLASS-NAME: stringliste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Listen von Strings und alle
//	notwendigen Operationen auf Stringlisten. Die Listen werden mit FIFO
//	Prinzip verwaltet. Wichtig!!!!: zerstoerendes Lesen
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: Konstruktor ohne Argument
//		 Destruktor zerstoert Liste
//		 add_element(string_C): string_C wird in die Liste eingefuegt
//		 entnehme(): nimmt das aelteste Element aus der Liste (FIFO)
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class stringliste_C {
public:
   stringliste_C();
   ~stringliste_C();
   void add_element(string_C);
   string_C entnehme();
private:
   int aktuell_i;
   string_C **liste_a;
   int listengroesse_i;
   int max_listengroesse_i;
};
#endif
